#!/bin/sh

#
# Benchmarking Script
# Geoff Wong Phd - 2002
#
# Runs a bunch of tests and collects timing information
#


#
# Also:
# 
# test .c with gprof  (time and gprof info)             
# versus with monitoring system (time and similar info)
# 
# both single/dual system
# 

export PATH=/home/geoff/gerl/bin:/home/geoff/gerl/lib:/bin:/usr/local/bin
export LD_LIBRARY_PATH=/home/geoff/gerl/lib:/home/geoff/gerl/erlib:.

httpd=httpd
monitor=$httpd\_mon.so
bench=BENCH.log

USAGE="Usage: `basename $0` [ -p <port> ] [ -d <hammer conf file> ] [ -h ] [ -v ]"

# Check the # of args
#if [ $# -lt 2 ]
#then
#	    printf "Insufficient args - %s\n" "$USAGE"
#	    exit 3
#fi 

# Defaults
port=3000

shift `expr $OPTIND`

while getopts :p:vhd: arg
do
    case $arg in
	d)
	    config="$OPTARG";;
	p)
	    port="$OPTARG";;
	v)
	    verbose=true;;
    h)
	    printf "Help - %s\n" "$USAGE"
	    exit 0;;
	\?)
	    printf "Options - %s\n" "$USAGE"
	    exit 2;;
    esac
done

run_bench()
{
    echo Benchmarking: $1
    #echo >> $2
    echo -n "Benchmarking: $1 " >> $2
    # Collect the stats
    #date >> $2
    gerl "$1:run()" >> $2
    #date >> $2
    #echo >> $2
}

#
# Ensure local Erlang node is running (default port)
#

enode 11111 &

#
# Rename the monitor(s) temporarily
# (without monitor)
#

#mv $monitor $monitor.xxx

echo >> $bench
echo "Gerl Benchmarking" >> $bench
date >> $bench
run_bench "barnes" $bench
#run_bench "estone" $bench
run_bench "fib" $bench
#run_bench "huff" $bench
run_bench "length" $bench
run_bench "nrev" $bench
run_bench "nucleic2" $bench
run_bench "qsort" $bench
run_bench "smith" $bench
# run_bench "smith1" $bench
run_bench "tak" $bench

# run_bench "decode2.erl
# run_bench "decode1.erl


#
# Testing with monitoring
#

#mv $monitor.xxx $monitor
#run_hammer "with"


#
# Testing Using Open Source Erlang
#

echo >> $bench
echo OSE Benchmarking >> $bench
erl < erl_bench >> $bench

