%% Copyright (c) 1996 by Plan95.  All Rights Reserved 
%% Time-stamp: <98/05/26 15:21:09 cjo>
%% ====================================================================
%%  Filename : 	qsort.erl
%%  Module   :	qsort
%%  Group    :  Server 
%%  Purpose  :  
%%  Notes    : 
%%  History  :	* 1996-6-13 Christer Jonsson (d92cjo@csd.uu.se): Created.
%% CVS:<br>
%%    $Author: geoff $
%%    $Date: 2002/08/05 08:03:18 $
%%    $Revision: 1.20 $
%% ====================================================================
%% Exported functions (short description):
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

-module(qsort).
-compile(export_all).


run() ->
%   L = mkrandlist(500),
   L = mkrandlist(500),
%%   garbage_collect(),
%%   timing:reset(),
    statistics(runtime),
   iterate(8000, L),
    { _, User} = statistics(runtime),
    User
    .
%%   {qsort, timing:time(), timing:gc_time()}.

test() ->
   L = mkrandlist(1000),
   qsort(L).


iterate(0, _) -> ok;
iterate(X, L) -> 
   qsort(L),
   iterate(X-1, L).


qsort(L) ->
   qsort(L, []).

qsort([X|L], ReallyBigs) ->
   {S, B} = partition(L, X),
   SB = qsort(B, ReallyBigs),
   qsort(S, [X|SB]);
qsort([], Bigs) ->
   Bigs.


partition([X|Rest], Y) when X =< Y ->
   {ZS, ZB} = partition(Rest, Y),
   {[X|ZS], ZB};
partition([X|Rest], Y) ->
   {S, B} = partition(Rest, Y),
   {S, [X|B]};
partition([],_) -> 
   {[], []}.


mkrandlist(X) ->
   random:seed(),
   mkrandlist(X, []).

mkrandlist(0, L) ->
   L;
mkrandlist(X, L) ->
   mkrandlist(X-1, [random:uniform(1000000) | L]).
   %mkrandlist(X-1, [random(1000000) | L]).
