%    -*- Erlang -*- 
%    File:	color.erl  (~jb/projects/erl_tracer/color.erl)
%    Author:	Johan Bevemyr
%    Created:	Wed Sep 13 09:34:42 1995
%    Purpose:   Primitives for handling colors.
 
-module(color).
-export([color_scale/2]).
-compile(export_all).



%	A pixel is represented by a tupple of integers representing Red, 
%	Green and Blue. The maximum value of each component is 255.

	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Name: color_scale(Color, Scalar)
%
% Desc: Scale each color component with the scalar. The color components 
%       are maxed at 255. 

color_scale({R,G,B},S) -> 
    Rp = min(R*S,255),
    Gp = min(G*S,255),
    Bp = min(B*S,255),
    {Rp,Gp,Bp}.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Name: min(X,Y)
%
% Desc: returns the smallest of X and Y and truncates it to an integer.

min(X,Y) ->
    if
	X < Y -> trunc(X);
	true -> trunc(Y)
    end.
