%% Copyright (c) 1996 by Plan95.  All Rights Reserved 
%% Time-stamp: <96/12/20 10:26:31 cjo>
%% ====================================================================
%%  Filename : 	rt_util.erl
%%  Module   :	rt_util
%%  Group    :  Server 
%%  Purpose  :  
%%  Notes    : 
%%  History  :	* 1996-9-12 Christer Jonsson (d92cjo@csd.uu.se): Created.
%% CVS:<br>
%%    $Author: geoff $
%%    $Date: 1998/05/29 02:04:24 $
%%    $Revision: 1.1 $
%% ====================================================================
%% Exported functions (short description):
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

-module(rt_util).
-compile(export_all).


append(X, Y) -> 
    erlang:append(X, Y).



reverse(X) ->
    reverse(X, []).

reverse([H|T], Y) ->
    reverse(T, [H|Y]);
reverse([], X) ->
    X.



keysort(Index, [X]) -> [X];
keysort(Index, [])  -> [];
keysort(Index, X)   -> split_and_keysort(X, [], [], Index).




split_and_keysort([A,B|T], X, Y, Index) ->
    split_and_keysort(T, [A|X], [B|Y], Index);
split_and_keysort([H], X, Y, Index) ->
    split_and_keysort([], [H|X], Y, Index);
split_and_keysort([], X, Y, Index) ->
    keymerge(Index, keysort(Index, X), keysort(Index, Y), []).


keymerge(Index, X, Y) -> 
    keymerge(Index, X, Y, []).

keymerge(I, [H1|T1], [H2|T2], L) when element(I, H1) < element(I, H2) ->
    keymerge(I, T1,[H2|T2], [H1|L]);
keymerge(Index, T1, [H2|T2], L) ->
    keymerge(Index,T1, T2, [H2|L]);
keymerge(Index,[H|T], T2, L) ->
    keymerge(Index,T, T2, [H|L]);
keymerge(Index, [], [], L) ->
    reverse(L).


map(F, As, [Hd|Tail]) ->
    [apply(F, [Hd|As]) | map(F, As, Tail)];
map(F, As, []) -> [].


sum(L)          -> sum(L, 0).
sum([H|T], Sum) -> sum(T, Sum + H);
sum([], Sum)    -> Sum.


