%% Copyright (C) 1990, Ellemtel Telecommunications Systems Laboratories
%% File    : lib.erl
%% Author  : Robert Virding & a cast of thousands
%% Purpose : Some extra useful library functions.

-module(lib).

-export([flush_receive/0,error_message/2, progname/0, nonl/1]).

flush_receive() ->
    receive
	Any ->
	    flush_receive()
    after
	0 ->
	    ok
    end.

%%
%% Functions for doing standard system format i/o.
%%

error_message(Format, Args) ->
    io:format("** ~s **\n", [io_lib:format(Format, Args)]).

%% Return the name of the script that starts (this) erlang 
%%

progname() ->
    case init:get_flag('-progname') of
	{'-progname', Prog} ->
	    Prog;
	Other ->
	    no_prog_name
    end.

nonl([10]) -> [];
nonl([]) -> [];
nonl([H|T]) -> [H|nonl(T)].
