%% Copyright (C) 1991, Ellemtel Telecommunications Systems Laboratories
%% File    : math.erl
%% Author  : Joe Armstrong (Who can remember wot pi is)
%% Author  : Mike Williams (Who can't, doesn't know wot half the functions mean
%%                          but who wrote C interface)
%% Purpose : Some useful functions

-module(math).

-export([pi/0,acos/1,acosh/1,asin/1,asinh/1,atan/1,atanh/1,
	 atan2/2,cos/1,cosh/1,erf/1,erfc/1,exp/1,lgamma/1,
	 log/1,log10/1,pow/2,sin/1,sinh/1,sqrt/1,tan/1,tanh/1]).

pragma
#include <math.h>
end pragma;
.

pi() ->
    3.1415926535897932.


acos(X) ->
pragma
    return EValreal(acos(X.u.real));
end pragma;
.

acosh(X) ->
pragma
    return EValreal(acosh(X.u.real));
end pragma;
.

asin(X) ->
pragma
    return EValreal(asin(X.u.real));
end pragma;
.

asinh(X) ->
pragma
    return EValreal(asinh(X.u.real));
end pragma;
.

atan(X) ->
pragma
    return EValreal(atan(X.u.real));
end pragma;
.

atanh(X) ->
pragma
    return EValreal(atanh(X.u.real));
end pragma;
.

atan2(X,Y) ->
pragma
    return EValreal(atan2(X.u.real, Y.u.real));
end pragma;
.

cos(X) ->
pragma
    return EValreal(cos(X.u.real));
end pragma;
.

cosh(X) ->
pragma
    return EValreal(cosh(X.u.real));
end pragma;
.

erf(X) ->
pragma
    return EValreal(erf(X.u.real));
end pragma;
.

erfc(X) ->
pragma
    return EValreal(erfc(X.u.real));
end pragma;
.

exp(X) ->
pragma
    return EValreal(exp(X.u.real));
end pragma;
.

lgamma(X) ->
pragma
    return EValreal(lgamma(X.u.real));
end pragma;
.

log(X) ->
pragma
    return EValreal(log(X.u.real));
end pragma;
.

log10(X) ->
pragma
    return EValreal(log10(X.u.real));
end pragma;
.

pow(X,Y) ->
pragma
    return EValreal(pow(X.u.real, Y.u.real));
end pragma;
.

sin(X) ->
pragma
    return EValreal(sin(X.u.real));
end pragma;
.

sinh(X) ->
pragma
    return EValreal(sinh(X.u.real));
end pragma;
.

sqrt(X) ->
pragma
    if ((X.tag & LT_normal) == LT_number)
    {
        return EValint(sqrt(X.u.number));
    }
    return EValreal(sqrt(X.u.real));
end pragma;
.

tan(X) ->
pragma
    return EValreal(tan(X.u.real));
end pragma;
.

tanh(X) ->
pragma
    return EValreal(tanh(X.u.real));
end pragma;
.

