-module(queue).
-export([new/0, in/2, out/1, to_list/1]).

%% efficient implementation of fifo queues

new() -> {[], []}.

in(X, {In, Out}) -> {[X|In], Out}.

out({In, [H|Out]}) ->
	{{value, H}, {In, Out}};
out({[], []}) ->
	{empty, {[],[]}};
out({In, _}) ->
	out({[], lists:reverse(In)}).

to_list({In, Out}) ->
    lists:append(lists:reverse(In), Out).

