%% Copyright (C) 1993, Ellemtel Telecommunications Systems Laboratories
%% File     : unix.erl
%% Author   : Claes Wikstrom klacke@erix.ericsson.se
%% Date     : 9300915
%% Purpose  : unix interface

-module(unix).
-export([cmd/1]).

%% Author Claes Wikstrom

%% This module is extremely easy to use.
%% L = unix:cmd("ls -F") puts the output of ls -F into the
%% character list L


cmd(Cmd) ->
    Port = open_port({spawn,make_cmd(Cmd)},[stream,in,eof]),
    get_data(Port,[]).

get_data(Port,Sofar) ->
    receive
	{Port,{data,Bytes}} ->
	    get_data(Port,[Sofar|Bytes]);
	{Port,eof} ->
	    Port ! {self(),close},
	    receive
		{Port,closed} ->
		    true
	    end,
	    lists:flatten(Sofar)
    end.

make_cmd(Cmd) -> lists:concat(["sh -c '", Cmd, "'"]).
