/*
** $Id: allocs.h,v 1.25 2002/07/31 09:24:52 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/allocs.h,v $
** $Revision: 1.25 $
** $Date: 2002/07/31 09:24:52 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 1998
** geoff@serc.rmit.edu.au
**
** This is an experimental allocation package which allocates tuples
** on the local stack using alloca(). They're copied if they're returned.
*/

#ifndef _ALLOCS_H
#define _ALLOCS_H

#if defined(__cplusplus)
extern "C" {
#endif

/* FIX: should TC/TC2 should length of tuples too? */

/*    TC2(_V, LT_tuple, X, __FILE__, __LINE__), */ 
#define Eindex_tuple(_V, X) \
( \
    _V.u.tuple->e[X] \
)


/*    TC2(_V, LT_tuple, X, __FILE__, __LINE__), */  
#define Ecindex_tuple(_V, X) \
( \
    __vvv=_V.u.tuple->e[X], \
    _V.u.tuple->e[X].tag = _V.u.tuple->e[X].tag & ~LT_on_heap, \
    __vvv \
)

#if 0
#define Ecindex_tuple(_V, X) \
( \
    __vvv = _V.u.tuple->e[X], \
    (_V.u.tuple->e[X]).tag = (_V.u.tuple->e[X]).tag & ~LT_on_heap, \
    __vvv \
)
#endif

#define tuplealloc(V,sz) \
( \
	V.tag = LT_tuple, \
	V.u.tuple = (ETuple)malloc(sizeof(_Tuple) + sizeof(Val)*(sz-1)), \
	V.u.tuple->size = sz, \
	V \
)

#define EValatom(V,A) \
( \
    V.tag = LT_atom, \
    V.u.atom = malloc((strlen(A)+1) * sizeof(char)), \
    strcpy(V.u.atom, A), \
    V \
) 

#define EValcatom(V,A) \
( \
    V.tag = LT_atom, \
    V.u.atom = A, \
    V \
) 

#define EValnatom(_A, _len) \
( \
    __vvv.tag = LT_atom, \
    __vvv.u.atom = malloc(sizeof (char) * (_len + 1)), \
    memcpy(__vvv.u.atom, (_A), _len), \
    __vvv.u.atom[_len] = '\0', \
    __vvv \
)

#define binaryalloc(_size) \
({ \
    EBinary _v; \
    _v = (EBinary)malloc(sizeof(_Binary) + sizeof(char) * (_size-1)); \
    _v->size = _size; \
    _v; \
})

#define binaryfree(B)

#define EValbinary(S) \
( \
    __vvv.u.binary = (EBinary)malloc(sizeof(_Binary) + sizeof(char) * (S-1)), \
    __vvv.u.binary->size = S, \
    __vvv \
)

#define stringa_copy(s) \
({ \
    char * ret; \
    ret = (char *)malloc(sizeof(char) * (strlen(s)+1)); \
    strcpy(ret,s); \
    ret; \
})                                                                             

#define Eokay() \
    EValmatom("ok",2) 

#define Eok(v) \
    Emake_tuple(tuplemalloc(2), EValatom(__vvv,"ok"), v)

#define Eerror(emsg) \
    Emake_tuple(tuplemalloc(2), EValatom(__vvv,"error"), EValstring(__vvv,emsg))


#if defined(__cplusplus)
}
#endif

#endif
