
%%
%% Erlang Built-in-Functions Module
%% Contains skeleton code for Bifs
%% This is then partially processed into C
%% Further (direct) changes are then made to the C code
%%
%% Reference: Armstrong, Virding, Williams (1993): Concurrent
%%		Programming in ERLANG.
%%
%% Author: Geoff Wong
%%

-module(bif).
-export([abs/1]).

%% Name: abs/1
%%	takes a number and returns the absolute value
abs(N) ->
	if 
		N < 0 -> -N;
		N >= 0 -> N;
	end;
	
%%
%%
apply(Module,Function,ArgList) ->
	;


%%
%%
apply( {Module,Function} ,ArgList) ->
	;

%% Name: atom_to_list/1
%%	takes an Atom and converts it to a list of ASCII numbers
atom_to_list(Atom) ->
	;	

%% Name: date/0
%% 	returns a tuple containing { year, month, day }
date() ->
	{ 97, 9, 27 }	
	;

%% Name: element/2
%% 	return the nth element of a tuple
element(N, Tuple)
	;


%% Name: erase/0
%% 	returns the process dictionary and deletes it
erase() ->
	;

%% Name: erase/1
%% 	returns the value associated with Key and deletes it from
%%	the process dictionary (can return undefined)
erase(Key) ->
	;

%% Name: exit/2
%% 	sends an exit message to process (Pid), returns true
%%	equivalent to Pid ! { 'EXIT', self(), goodbye }
exit(Pid, Reason) ->
	Pid ! { 'EXIT', self(), Reason }

%% Name: float/1
%% 	converts a number to a float
float(Number) ->
	;

%% Name: float_to_list/1
%% 	returns a list of ASCII values corresponding to Float
float_to_list(Float) ->
	;

%% Name: get/0
%%	returns the process dictionary as a list of { Key, Value } tuples
get() ->
	;

%% Name: get/2
%% 	returns a value association with key in the process dictionary
get(Key) ->
	;

%% Name: get_keys/1
%%	returns a list of keys which correspond to Value in process dictionary
get_keys(Value) ->
	;

%% Name: halt/0
%%	halt the system
halt() ->
	;

%% Name: hd/1
%% 	return the head of a list
hd(List) ->
	;

%% Name: integer_to_list/1
%%  returns a list of ASCII values corresponding to Integer
integer_to_list(Integer) ->
	;

%% Name: length/1
%% 	returns the length of a list
length(List) ->
	;

%% Name: link/1
%%	make a link to a process/port of process Pid, returns true
link(Pid) ->
	;

%% Name: list_to_atom/1
%%	returns an atom whose textual representation is that of integers
list_to_atom(AsciiIntegerList) ->
	;

%% Name: list_to_float/1
%%	returns a float whose textual representation is that of inters
list_to_float(AsciiIntegerList) ->
	;
	
%% Name: list_to_integer/1
%%	returns an integer whose textual representation is that of inters
list_to_integer(AsciiIntegerList) ->
	;

%% Name: list_to_pid/1
%%	returns a pid whose textual representation is that of inters
list_to_pid(AsciiIntegerList) ->
	;

%% Name: list_to_tuple/1
%%	returns a tuple whose textual representation is that of inters
list_to_tuple(AsciiIntegerList) ->
	;

%% Name: make_ref/0
%% 	returns a unique reference
make_ref() ->
	;

%% Name: node/0
%% 	returns an erlang term which represents the current node
node() ->
	;

%% Name: node/1
%% 	returns an erlang term which represents the node on which Pid
%%	was opened.
node(Pid) ->
	;

%% Name: open_port/2
%%	returns a port wehich is the result of opening a port
open_port(PortName, PortSettings) ->
	;

%% Name: pid_to_list/1 ->
pid_to_list(Pid) ->
	;

%% Name: process_flag/2
%% 	set certain flags for the process which calls this function
%%	returns the old value of the flag
process_flag(Flag,Option) ->
	;

%% Name: process_info/1
%%	returns a long list containg information about the process Pid
%%	notes: used for debugging only
process_info(Pid) ->
	;

%% Name: processes/0
%% 	returns a list of all process on the current noed
processes() ->
	;

put(Key, Value) ->
	;

register(Name, Pid) ->
	;

registered() ->
	;

round(Number) ->
	;

self() ->
	;

setelement(Index,Tuple,Value() ->
	;

size(Tuple) ->
	;

spawn(Module, Function, ArgumentList) ->
	;

spawn_link(Module, Function, ArgumentList) ->
	;

statistics(Type) ->
	;

term_to_words(Term) ->
	;

throw(Any) ->
	;

time() ->
	;

tl(List) ->
	;

trunc(Number) ->
	;

tuple_to_list(Tuple) ->
	;

unlink(Pid) ->
	;

unregister(Name) ->
	;

whereis(Name) ->
	;

words_to_term(List) ->
	;



