
/*
** $Id: blist.h,v 1.8 1999/11/24 12:47:49 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/blist.h,v $
** $Revision: 1.8 $
** $Date: 1999/11/24 12:47:49 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 1998
** geoff@serc.rmit.edu.au
*/

#ifndef _LIST_H
#define _LIST_H


/*
 * List header representation
 *
 */

typedef struct _list 
{
    int size;
        // Size of memory allocated
    int length;
        // Length of the list
    int e;
        // Offset of list start into the memory
    struct _list * memholder;
        // Pointer to the list actually holding the memory
        // Start always accessed through memholder?
        // Might point to itself
    Val * start;
        // Actual allocated memory
} _List;

typedef struct _list * List;

typedef struct _paramlist
{
        int size;
        Val * e;
} _ParamList;

typedef struct _paramlist * ParamList;

Val parammalloc(int x);
int listcmp(Val x, Val y);

#define Lsize(_V) (_V.u.list->size)  

#define Elist_size(_V,_sz) (_V.u.list->size)  

#define Elist_gsize(_V,_sz) (_V.u.list->size >= _sz)  

#define Eindex_list(_V, X) (_V.u.list->memholder->start[_V.u.list->e+X])

#define Ehead_list(_V) (_V.u.list->memholder->start[_V.u.list->e])

#if 0
#define listalloc(V,_sz) \
( \
	V.tag = LT_list, \
    V.u.list = (List) alloca(sizeof(_List)), \
	V.u.list->size=(_sz),  \
    V.u.list->e = (Val*)(alloca(sizeof(Val)*(_sz))), \
	V \
)
#define EValstring(V,_atom) \
( \
	V.tag = LT_list, \
	V.u.list = (List)alloca(sizeof(_List)), \
	V.u.list->size = strlen(_atom), \
    V.u.list->e = (Val*)(alloca(sizeof(Val)*V.u.list->size)), \
    ({ int __iii; for (__iii = 0; __iii < V.u.list->size; __iii++) \
        V.u.list->e[__iii] = EValint((_atom)[__iii]); }), \
    V \
)
#endif

#define Ebytes_to_list(_bytes, sz) \
({ \
    Val _v; \
    int i; \
	_v.tag = LT_list; \
	_v.u.list = (List)alloca(sizeof(_List) + sizeof(Val)*(sz-1)); \
	_v.u.list->size = sz; \
    for (i = 0; i < sz; i++) \
    { \
        _v.u.list->memholder->start[_v.u.list->e+i] = EValint(_bytes[i]); \
    } \
    _v; \
})

#define Eemptylist() \
( \
    __vvv.tag = LT_list, \
    __vvv.u.list = (List) alloca(sizeof(_List)), \
    __vvv.u.list->size=(_sz), \
    __vvv.u.list->e = 0, \
    __vvv \
)
                             
#endif

