
/*
** $Id: clist.h,v 1.9 2002/08/08 13:39:42 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/clist.h,v $
** $Revision: 1.9 $
** $Date: 2002/08/08 13:39:42 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 2001
** geoff@serc.rmit.edu.au
*/

#ifndef _LIST_H
#define _LIST_H

//
// List member storage - maybe shared.
//
typedef struct _list_member
{
    unsigned int ref;
        // Ref count
    unsigned int first;
        // First used element
    unsigned int size;
        // Size of memory allocated
    Val mem[1];
} _List_member;

typedef struct _list_member * ListMember;

//
// The actual list structure itself.
//
typedef struct _list 
{
    unsigned int ref;
        // # of refs to this 
    unsigned int length;
        // Length of the list
    unsigned int start;
        // Offset of list start into the memory
    ListMember e;
        // Pointer to the list actually holding the memory
        // Start always accessed through memholder?
        // Might point to itself
} _List;

typedef struct _list * List;

typedef struct _paramlist
{
        int size;
        Val * e;
} _ParamList;

typedef struct _paramlist * ParamList;

// Local defs..
Val parammalloc(int x);
int listcmp(List x, List y);
int listcmp(List x, List y);
void listfree(Val x);

// testing
// inline Val Etail_listd(Val l, int arg, const char * from);
inline void Efred(Val l);

#define Elist_size(_V,_sz) (_V.u.list->length == _sz)  

#define Elist_gsize(_V,_sz) (_V.u.list->length >= _sz)

#define Eindex_list(_V, X) (_V.u.list->e->mem[_V.u.list->start+X])


// destructive tail_list 
#define Etail_listd(l, arg, from) \
    ((l.tag & LT_on_heap) ? \
        (l.tag = LT_list, \
        __vvv.u.list = alloca(sizeof(_List)), \
        memcpy(__vvv.u.list, l.u.list, sizeof(_List)), \
        l.u.list = __vvv.u.list, \
        l.u.list->length--, \
        l.u.list->start++, \
        l) : (l.u.list->length--, l.u.list->start++, l))

#if 0
#define listalloc(V,_sz) \
( \
	V.tag = LT_list, \
    V.u.list = (List) alloca(sizeof(_List)), \
	V.u.list->size=(_sz),  \
    V.u.list->e = (Val*)(alloca(sizeof(Val)*(_sz))), \
	V \
)
#define EValstring(V,_atom) \
( \
	V.tag = LT_list, \
	V.u.list = (List)alloca(sizeof(_List)), \
	V.u.list->size = strlen(_atom), \
    V.u.list->e = (Val*)(alloca(sizeof(Val)*V.u.list->size)), \
    ({ int __iii; for (__iii = 0; __iii < V.u.list->size; __iii++) \
        V.u.list->e[__iii] = EValint((_atom)[__iii]); }), \
    V \
)

#define Eemptylist() \
( \
    __vvv.tag = LT_list, \
    __vvv.u.list = (List) malloc(sizeof(_List)), \
    __vvv.u.list->size=(_sz), \
    __vvv.u.list->start = 0, \
    __vvv \
)
                             

#define Ebytes_to_list(_bytes, sz) \
({ \
    Val _v; \
    int i; \
    _v = listmalloc(sz); \
    for (i = 0; i < sz; i++) \
    { \
        _v.u.list->e->mem[_v.u.list->start+i] = EValint(_bytes[i]); \
    } \
    _v; \
})

#endif

#endif
