
/*
** $Id: code.c,v 1.2 2001/12/02 12:25:29 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/code.c,v $
** $Revision: 1.2 $
** $Date: 2001/12/02 12:25:29 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 1998
** geoff@serc.rmit.edu.au
*/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "ehash.h"
#include "code.h"
#include "str.h"

int code_key(Hash_table HT, void * key)
{
#ifdef DEBUG
fprintf(stderr, "code_key = %d\n", (unsigned int) key);
#endif
	return hashstr((char *)key, HT->size);
}

int code_hash(Hash_table HT, void * key)
{
#ifdef DEBUG
fprintf(stderr, "code_hash = %s\n", (unsigned int) ((Code_handle)key)->name);
#endif
	return hashstr(((Code_handle)key)->name, HT->size);
}

int code_match(Hash_table HT, void * element, void * key)
{
	char * s;
	Code_handle c;
	
	s = (char *) key;
	c = (Code_handle) element;
	
#ifdef DEBUG
fprintf(stderr, "code_match: %d = %d\n", c->pid, s);
#endif

	if (strcmp(c->name, s) == 0) 
    { 
        /* found it */
		return 1;
	}
	return 0;
}

Code_handle
make_code_handle(const char *name, void * handle)
{
   Code_handle ret;

   ret = (Code_handle) malloc(sizeof(struct CODE_HANDLE));
   ret->name = string_copy(name);
   ret->handle = handle;

   return ret;
}

