


/*
** $Id: cons.h,v 1.9 1998/11/27 06:41:51 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/cons.h,v $
** $Revision: 1.9 $
** $Date: 1998/11/27 06:41:51 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 1998
** geoff@serc.rmit.edu.au
*/

/*
** Possible cons cell implementation of lists
**
** Each list eats 33% more space in this scheme
*/

#ifndef _CONS_H
#define _CONS_H

#include "erlib.h"

typedef struct _lelement
{
    Val e;
    struct _lelement * next;
} _Lelement;

#if 0
typedef struct _list
{
    int size;
    _Lelement * head;
} _List;
#endif

typedef struct _paramlist
{
        int size;
        Val * e;
} _ParamList;

typedef struct _paramlist * ParamList;

_Lelement * make_lelement(Val x);
_Lelement * make_block_lelement(int x);
Val parammalloc(int x);

/* Note: we assume the index will be valid .. */
#define Eindex_list(_V, X) \
({ \
    _Lelement * le = _V.u.list; \
    int count = X; \
    while (le && count) \
    { \
        le = le->next; \
        count--; \
    } \
    le->e; \
})

/* return true is list is of size X */
#define Elist_size(_L,X) \
({ \
    _Lelement * le = _L.u.list; \
    int i; \
    for (i = X; i && le; i--) \
        le = le->next; \
    (le == 0 && i == 0) ? 1 : 0; \
})

#define Elist_gsize(_L,X) \
({ \
    _Lelement * le = _L.u.list; \
    int i; \
    for (i = X; i && le; i--) \
        le = le->next; \
    (i == 0) ? 1 : 0; \
})

#define Ehead(_V) (_V.u.list->e)
#define Etail(_V) (_V.u.list->next)
#define Eis_full_list(X) ((X.tag & LT_list) && X.u.list)
#define Eis_empty_list(X) ((X.tag & LT_list) && !(X.u.list))

#if 0
#define EValstring(V,_atom) \
({ \
    _Lelement * le = V.u.list; \
    int count = 0; \
    V.tag = LT_list | LT_on_heap; \
    V.u.list = make_block_lelement(strlen(_atom)); \
    while (le) \
    ({ \
        le->e = EValint((_atom)[count]); \
        le = le->next; \
        count++; \
    }) \
    V; \
})
#endif

#define Ebytes_to_list(_bytes, sz) \
({ \
    Val V; \
    _Lelement * le; \
    int count = 0; \
    V.tag = LT_list | LT_on_heap; \
    V.u.list = make_block_lelement(sz); \
    le = V.u.list; \
    while (le) \
    { \
        le->e = EValint((_bytes)[count]); \
        le = le->next; \
        count++; \
    } \
    V; \
})

#endif


