/*
** $Id: esocket.h,v 1.4 1999/01/13 00:54:22 geoff Exp $
**
** Socket object
** Basically a container for all the C stuff
**
** $Source: /home/cvs/gerl/lib/esocket.h,v $
** $Revision: 1.4 $
** $Date: 1999/01/13 00:54:22 $
** $State: Exp $
**
** Author: Geoff Wong
*/
#ifndef _MYSOCKET_H
#define _MYSOCKET_H

#if 0
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <strings.h>
#ifdef SunOS
#include <inet/tcp.h>
#else
#include <netinet/tcp.h>
#endif
#endif

#include "str.h"
#include "erlib.h"

typedef struct _socket 
{
    int     socket_no;
    unsigned long    int_address;
    int     string_address;
    int     port;
    int     family;
    int     socket_type;
    int     protocol;

    char *     hostname;
    char *  error;
} * Socket;


Socket Ecreate_socket(int domain, int type, int prot);
    /* create a socket of a certain name  */

Socket Eaccept(Socket);

int Ebind(Socket, int port_number);

int Ebind_str(Socket, const char * name);
    /* bind our socket to a name */

int Eclose(Socket);

int Econnect(Socket, Val pidtuple);

int Econnect_str_port(Socket, const char * address, unsigned int port);

int Econnect_add_port(Socket, unsigned long addr, unsigned int port);

void Connectto(Socket, const char * address, unsigned int port);
    /* Connect()s returns 0 on failure */
    /*            returns 1 on success */

int Fileno(Socket);

char * Getpeername(Socket);

char * Getsockopt(Socket,int level, int optname, int buflen);

int Fcntl(Socket, int, void * arg);
    /* Do ioctl/fcntl on a socket (very system dependent). */

int Ioctl(Socket, int, void * arg);
    /* Do ioctl/fcntl on a socket (very system dependent). */

int Listen(Socket, int backlog);        
    /* listen for a stream connection on our socket */

EBinary Erecv(Socket, int bufsize);
    /* Returns the data and length received. 		  */
    /* The EBinary is allocated (and must be deleted) */

EBinary Recvfrom(Socket, int bufsize, Socket);
    /* Store the return info in the given socket */

int Esendbinary(Socket S, EBinary bin);
    /* Send a block of memory down the pipe */

int Sendto(Socket, const char * what);

int Setblocking(Socket, int flags);
    /* set blocking/nonblock mode for the socket */

int Setsockopt(Socket, int level, int optname, char * value);

int Eshutdown(Socket, int how);
    /* shut me down gracefully  */

void Set_error(Socket, const char * how);

char * Ip_number(Socket);

char * Hostname();
    /* return the current hostname */

#define MAX_MESSAGE 65536

#endif
