
/*
** $Id: message.h,v 1.7 2002/04/18 14:25:25 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/message.h,v $
** $Revision: 1.7 $
** $Date: 2002/04/18 14:25:25 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 1998
** geoff@serc.rmit.edu.au
*/

#ifndef _MESSAGE_H
#define _MESSAGE_H

typedef enum
{
    Ext_small_integer = 97,
    Ext_integer       = 98,
    Ext_float         = 99,
    Ext_atom          = 100,
    Ext_reference     = 101,
    Ext_port          = 102,
    Ext_pid           = 103,    /* non-standard */ 
    Ext_small_tuple   = 104,
    Ext_large_tuple   = 105,
    Ext_nil           = 106,
    Ext_string        = 107,
    Ext_list          = 108,
    Ext_binary        = 109,
    Ext_small_big     = 110,
    Ext_large_big     = 111,
    Ext_bool          = 112     /* non-standard */
} External;

typedef enum
{
    C_invalid = 0,
    C_link = 1,
    C_send = 2,
    C_exit = 3,
    C_unlink = 4,
    C_node_link = 5,
    C_reg_send = 6,
    C_group_leader = 7,
    C_exit2 = 8,
    C_magic = 9,
    C_goahead = 10,
    C_goahead_magic = 11,
    C_spawn = 12
} Control;


/*
** We just use this as a `record' to address Erlang tuples
** representing Pids. Allows us to change them a bit too.
** Really it's just a bunch of defines rather than an enum type.
*/
typedef enum
{
    Pid_ipaddr = 0,
    Pid_port = 1,
    Pid_pid = 2, 
    Pid_size = 3
} Pid;

typedef struct _LENVAL
{
    int len;
    Val v;    
} LenVal;

#define VERSION_MAGIC 132

/*
** Default port for the Erlang node to receive messages
** Should we do this or just allocate dynamically?
*/

#define DEFAULT_NODE_PORT 11111
#define LOCAL_HOST 0x0100007f

#endif
