/*
** $Id: typecheck.c,v 1.10 2002/07/31 09:24:53 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/typecheck.c,v $
** $Revision: 1.10 $
** $Date: 2002/07/31 09:24:53 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 1998
** geoff@serc.rmit.edu.au
*/

#include <assert.h>
#include "typecheck.h"
#include "erlib.h"

/* can throw an Erlang runtime error */
inline void TC(Val v, Etype t, int arg, const char * where)
{
    if ((v.tag & t) == 0)
    {
        Ethrowv("Illegal type (%d) at arg %d in %s\n", v.tag, arg, where);
        return;
    }
}

inline void TC2(Val v, Etype t, int arg, const char * file, int line)
{
    if ((v.tag & t) == 0)
    {
        Ethrowv("Illegal type (%d) at arg %d: %s (%d)\n", v.tag, arg, file, line);
        return;
    }
}

inline void TCM(Val v, Etype t, const char * file, int line)
{
    if ((v.tag & t) == 0)
    {
        Ethrowv("Pattern match failure in %s:%d, expected %d got %d.\n", 
                        file, line, t, v.tag);
        return;
    }
}

inline void TCEQ(Val v1, Val v2, const char * where)
{
    assert((v1.tag & v2.tag) != 0);

    if ((v1.tag & v2.tag) == 0)
    {
        Ethrowv("Distinct types applied to operation: %s (%d)\n", where);
        return;
    }
}

inline void TCEQ2(Val v1, Val v2, const char * file, int line)
{
    assert((v1.tag & v2.tag) != 0);

    if ((v1.tag & v2.tag) == 0)
    {
        Ethrowv("Distinct types applied to operation: %s (%d)\n", file, line);
        return;
    }
}
