
/*
** $Id: typecheck.h,v 1.4 1999/11/22 14:40:41 geoff Exp $
**
** $Source: /home/cvs/gerl/lib/typecheck.h,v $
** $Revision: 1.4 $
** $Date: 1999/11/22 14:40:41 $
** $State: Exp $
**
** Author: Geoff Wong
** Copyright(C) 1998
** geoff@serc.rmit.edu.au
*/

#ifndef _TYPECHECK_H
#define _TYPECHECK_H

#include "erlib.h"

/* These functions do runtime checking and will throw Erlang errors */

inline void TC(Val v, Etype t, int arg, const char * where);
inline void TC2(Val v, Etype t, int arg, const char * file, int line);
inline void TCM(Val v, Etype t, const char * file, int line);
    /* Name: TC 
    ** Purpose: Typecheck a value, v, to ensure it's a certain type, t,
    **      arg - it the # of the argument it was (ie. 1st, 2nd, 3rd, etc)
    **      where - information, tell us what function failed
    */

inline void TCEQ(Val v1, Val v2, const char * where);

inline void TCEQ2(Val v1, Val v2, const char * file, int line);
    /* Name: TCEQ
    ** Purpose: Ensure two value are of the same type
    */

#endif
