/*
** Message: send a message to a specified port (in correct format).
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/telnet.h>
#include <netdb.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>

#define IP_PROT 0
#include "protocol.h"

main(int argc, char * argv[])
{
    struct sockaddr_in sin, addr;
    byte * outbuf;
    int S;

    if (argc < 3)
    {
        fprintf(stderr, "message <port> <message>\n");
        exit(1);
    }
    
    S = socket(AF_INET, SOCK_STREAM, IP_PROT);

    memset((char *) &sin, '\0', sizeof sin);
    sin.sin_family = AF_INET;
    sin.sin_port = htons(atoi(argv[1]));
    sin.sin_addr.s_addr = 0x0100007f;

    if (connect(S, &sin, sizeof sin) == -1)
    {
        fprintf(stderr, "Failed to connect() to host.\n");
        exit(1);
    }
    
    printf("Connected\n");

    outbuf = malloc(strlen(argv[2]) + 3);
    outbuf[0] = VERSION_MAGIC;
    outbuf[1] = P_atom_ext;
    strcpy(&outbuf[2], argv[2]);
    if (send(S, outbuf, strlen(outbuf), 0) == -1)
    {
        fprintf(stderr, "Failed to send() message (%d).\n", errno);
        exit(1);
    }
     
    shutdown(S,2);
    close(S);
    return 0;
}
