#ifndef _BASIC_H
#define _BASIC_H

#include "node.h"
#include "symbol.h"
#include "program.h"

class Atom : public Node
{
    string storage;
	string value;
public:
	Atom(const string& tmp, const string * at);
	string print();
	list<string> emit_code();
	string emit_pattern(string p);
	
};

class Number : public Node
{
	int value;
public:
	Number(int num);
	string print();
	list<string> emit_code();
	string emit_pattern(string p);
};

class Real : public Node
{
	string value;
        //  we keep it as a string so it's easier to print
        // need to keep both num and string at some stage for
        // constant folding?
public:
	Real(string& num);
	string print();
	list<string> emit_code();
	string emit_pattern(string p);
};

// Estring - Erlang string (to distinguish this from a C++ string)
class Estring : public Node
{
    string storage;
	string value;
public:
	Estring(const string& tmp, const string * str);
	string print();
	list<string> emit_code();
	string emit_pattern(string X);
};

class Variable : public Node
{
	string value;
public:
	Variable();
	Variable(const string * str);

	string print();
	list<string> emit_code();
	string emit_pattern(string x);
    void add_symbol(SymbolTable *, int df = LT_none);
    int type();
    void type(int);
};


class Boolean : public Node
{
	bool value;
public:
	Boolean();
	Boolean(int);
	string print();	
	list<string> emit_code();
	string emit_pattern(string X);
};


#endif
