
//
// $Id: binary.h,v 1.4 2002/11/06 12:47:30 geoff Exp $
//
// $Source: /home/cvs/gerl/src/binary.h,v $
// $Revision: 1.4 $
// $Date: 2002/11/06 12:47:30 $
// $State: Exp $
//
// Copyright (C) Geoff Wong (1996, 1997, 1998)
// geoff@cs.rmit.edu.au
//
// This file is distributed under the terms of the
// GNU Public License, details of which can be found
// in the file "Copying" which accompanies this code.        
//

#ifndef BINARY_H
#define BINARY_H

#include "nodes.h"

// Standard binary operates (with the same behaviour)
class Binary : public Node
{
protected:
	Node * LHS, * RHS;
	string operate;

    int tag_code(Node * node, string& res, string& append);
        // appends the union type extraction code (if a single type)
        // nothing appended if it's a constant > T_token (etc)
        // returns the type of the expression found

    string type_code(Node * L);
        // return a string representing the type passed in..

public:
	Binary(string *, Node *, Node *);

	Binary(const string& op, Node * l, Node * r);
	list<string> emit_code();
	string print();
};

class PlusExpr : public Binary
{
public:
    PlusExpr(Node * l, Node * r);

    list<string> emit_code();
};

class MinusExpr : public Binary
{
public:
    MinusExpr(Node * l, Node * r);
    list<string> emit_code();
};

class MultiplyExpr : public Binary
{
public:
    MultiplyExpr(Node * l, Node * r);
    list<string> emit_code();
};

class DivideExpr : public Binary
{
public:
    DivideExpr(Node * l, Node * r);
    list<string> emit_code();
};

class BorExpr : public Binary
{
public:
    BorExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class BxorExpr : public Binary
{
public:
    BxorExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class BslExpr : public Binary
{
public:
    BslExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class BsrExpr : public Binary
{
public:
    BsrExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class BandExpr : public Binary
{
public:
    BandExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class DivExpr : public Binary
{
public:
    DivExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class RemExpr : public Binary
{
public:
    RemExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class ConcatExpr : public Binary
{
public:
    ConcatExpr(Node * l, Node * r);
    // list<string> emit_code();
};

class ListSubtract : public Binary
{
public:
    ListSubtract(Node * l, Node * r);
    // list<string> emit_code();
};

#endif
