
//
//	Erlang Compiler with Monitoring Support
//
//	Geoff Wong (C) Copyright 1996,1997,1998.
//	C/O RMIT University
//	Swanston St. Melbourne 3001.
//	Australia
//
//	email: geoff@serc.rmit.edu.au
//
//	This file is distributed under the terms of the 
//	GNU Public License, details of which can be found
//	in the file "Copying" which accompanies this code.
//

#include "str.h"
#include "define.h"


Define::Define(string r)
{
    defstring = r;
}

Define::Define(string r, ExprList * exp)
{
    defstring = r;
    v = exp;
}

list<string> Define::emit_code()
{
    return string2list(defstring);
}

string Define::print()
{
    return ""; 
}

DefClause::DefClause(string r, NodeList * n)
{
    _defstring = r;
    _v = n;
}

void DefClause::body(string x)
{
    _body = x;
}

string DefClause::body()
{
    return _body;
}

string DefClause::defstring()
{
    return _defstring;
}

NodeList * DefClause::plist()
{
    return _v;
}

list<string> DefClause::emit_code()
{
    list<string> ret;
    return ret;
}

string DefClause::print()
{
    return "";
}

