
//
//	Erlang Compiler with Monitoring Support
//
//	Geoff Wong (C) Copyright 1996,1997,1998.
//	C/O RMIT University
//	Swanston St. Melbourne 3001.
//	Australia
//
//	email: geoff@serc.rmit.edu.au
//
//	This file is distributed under the terms of the 
//	GNU Public License, details of which can be found
//	in the file "Copying" which accompanies this code.
//

#ifndef _DEFINE_H
#define _DEFINE_H

#include "node.h"
#include "expr.h"

class Define : public Node
{
	string 	defstring;

public:
    ExprList * v;

	Define(string r);
	Define(string r, ExprList * exp);

	list<string> emit_code();
	string print();	
};

class DefClause : public Node
{
    string _body;
    string _defstring;
    NodeList * _v;

public:
	DefClause(string r, NodeList *);

    string defstring();
    string body();
    NodeList * plist();

    void body(string x);

	list<string> emit_code();
	string print();	
};


#if 0
class DefElement : public Node
{
    string defstring;

public:
    DefElement(string x);

    list<string> emit_code();
    string print();
}
#endif


extern void add_define(DefClause *);

#endif
