
//
// $Id: elist.h,v 1.17 2001/10/17 14:31:42 geoff Exp $
//
// $Source: /home/cvs/gerl/src/elist.h,v $
// $Revision: 1.17 $
// $Date: 2001/10/17 14:31:42 $
// $State: Exp $
//
// Copyright (C) Geoff Wong (1996, 1997, 1998)
// geoff@cs.rmit.edu.au
//
// This file is distributed under the terms of the
// GNU Public License, details of which can be found
// in the file "Copying" which accompanies this code.        
//

#ifndef _ELIST_H
#define _ELIST_H

#include <stdio.h>
#include "node.h"
#include "symbol.h"

class EList : public NodeList
{
    string storage;
    string tmpstore1;
    string tmpstore2;
    string tmpstore3;
    Node * tail;

    Symbol * post;

public:
    EList(const string& tmp);
    EList(const string& tmp, const string& tmp1, const string& tmp2,
            const string& tmp3, Node *);

    ~EList();
        // destructor

    list<string> emit_code();
    //list<string> pre_code() { return string2list("fuck"); }

    string emit_pattern(string p);
    string print();
    void set_depth(int);
    void add_symbol(SymbolTable * st, int dt = LT_none);
    bool typecheck(Etype check, Etype restrict);
    void type(int);

    // Symbol * assign();
        // A hacky use of assign for ExprList::emit_code
        // so Elist can emit pre-code
        // emit_code() must be called before the "symbol" is set.
};

#if 0
class ETail : public Node
{
    Node * value;
public:
    ETail();
    ETail(Node *);

    list<string> emit_code();
    string print();
};

#endif

#endif
