#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "erlang.y"


/**/
/* $Id: erlang.cc,v 1.153 2004/09/05 02:42:56 geoff Exp $*/
/**/
/* $Source: /home/cvs/gerl/src/erlang.cc,v $*/
/* $Revision: 1.153 $*/
/* $Date: 2004/09/05 02:42:56 $*/
/* $State: Exp $*/
/**/
/* Author: Geoff Wong*/
/**/
/* Geoff Wong - Copyright 1997 - 2002.*/
/**/
/**/
/* @@DOC*/
/* <h2> The Parser </h2>*/
/* */
/* The grammar for the Erlang parser was taken from the book*/
/* "Concurrent Programming in ERLANG", Armstrong et al, 1993.*/
/* It implements the Erlang 4.2 (or 3?) specifiction.*/
/* The yacc grammar itself constructs an abstract syntax tree*/
/* which is further processed depending on the type of compilation*/
/* being performed.*/
/* @@ENDDOC*/
/**/


#include <stdarg.h>
#include <stdio.h>
#include <list>
#include <iostream>

#include "nodes.h"
#include "guard.h"
#include "binary.h"
#include "pattern.h"
#include "match.h"
#include "program.h"
#include "expr.h"
#include "case.h"
#include "farity.h"
#include "pragma.h"
#include "define.h"
#include "yy.h"
#include "str.h"
#include "tuple.h"
#include "function.h"
#include "catch.h"
#include "namer.h"
#include "record.h"
#include "unary.h"
#include "list_comp.h"

extern int current_line;
extern char * current_file;

extern int debug;

Program 			* yy_program;
static int			clause_id = 0;
static int			cr_id = 0;
static int			if_id = 0;
static int          tmp_val_count = 0;
/* static int          tmp_alloc_count = 0;*/
static Symbol       * retsymbol = 0;
/* static SymbolTable  * function_table;*/
static FunctionList * active_function;

int yyerrorf(const char *fmt, ...);

#line 74 "erlang.y"
typedef union {
	int number;
    float real;
	char * cstring;
	char * var;
	string * stringp;
	int truth;
	Node * node;
	NodeList * nodelist;
	CaseList * caselist;
	ExprList * exprlist;;
	FunctionList * funclist;
	FormList * formlist;
	Attribute * attribute;
	DefClause * defclause;
} YYSTYPE;
#line 101 "y.tab.c"
#define T_bor 257
#define T_bxor 258
#define T_bsl 259
#define T_bsr 260
#define T_equal 261
#define T_notequal 262
#define T_le 263
#define T_lt 264
#define T_ge 265
#define T_gt 266
#define T_exactequal 267
#define T_div 268
#define T_rem 269
#define T_band 270
#define T_bnot 271
#define T_atom 272
#define T_number 273
#define T_string 274
#define T_var 275
#define T_bool 276
#define T_begin 277
#define T_catch 278
#define T_concat 279
#define T_listsub 280
#define T_case 281
#define T_of 282
#define T_if 283
#define T_receive 284
#define T_after 285
#define T_end 286
#define T_when 287
#define T_arrow 288
#define T_dot 289
#define T_define 290
#define T_defbody 291
#define T_record 292
#define T_fun 293
#define T_such 294
#define T_generator 295
#define T_rechash 296
#define T_form 297
#define T_plus 298
#define T_minus 299
#define T_multiply 300
#define T_divide 301
#define T_idiv 302
#define T_exprtail 303
#define T_patternlist 304
#define T_patterntail 305
#define T_pattern 306
#define T_tuple 307
#define T_bracket 308
#define T_exprs 309
#define T_list 310
#define T_funcall 311
#define T_remotefuncall 312
#define T_ifclause 313
#define T_match 314
#define T_many 315
#define T_guardtail 316
#define T_guardcall 317
#define T_biftest 318
#define T_guardtest 319
#define T_guardtests 320
#define T_funcclause 321
#define T_clausehead 322
#define T_clausebody 323
#define T_farity 324
#define T_attribute 325
#define T_patterntuple 326
#define T_function 327
#define T_send 328
#define T_pragma 329
#define T_endpragma 330
#define T_text 331
#define T_real 332
#define CATCH 333
#define SEND_OP 334
#define COMP_OP 335
#define LIST_OP 336
#define ADD_OP 337
#define MULT_OP 338
#define UNARY 339
#define UPLUS 340
#define UMINUS 341
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,   54,   54,    6,    6,    6,   64,    6,    6,   60,
   60,   36,   36,    3,    3,    3,    3,    3,    3,    2,
    2,    2,    2,    2,    5,    5,    5,    5,    5,    5,
    5,    4,    4,    4,   13,   13,   13,   13,   13,   13,
   13,   13,   14,   14,   14,   14,   62,   62,   61,   61,
   37,    9,    9,    9,   58,   58,   57,   57,   57,    8,
    8,   56,   56,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,    7,   52,   52,   42,   42,   46,
   46,   65,   39,   39,   39,   12,   12,   15,   15,   15,
   49,   49,   17,   16,   10,   47,   47,   18,   34,   66,
   35,   40,   40,   19,   19,   19,   67,   32,   20,   21,
   48,   48,   48,   22,   22,   22,   22,   22,   22,   22,
   22,   45,   45,   44,   44,   44,   23,   23,   51,   51,
   24,   50,   50,   25,   26,   26,   41,   41,   27,   27,
   68,   38,   28,   69,   29,   55,   55,   30,   30,   31,
   31,   53,   53,   59,   59,    1,    1,   63,   63,   63,
   63,   43,   43,   33,
};
short yylen[] = {                                         2,
    1,    2,    3,    5,    8,    5,    0,    2,    1,    1,
    3,    1,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    4,    1,    5,    7,    1,    5,    0,    1,    1,    3,
    3,    1,    1,    1,    2,    4,    2,    3,    0,    2,
    3,    1,    3,    1,    6,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    2,    2,    2,
    3,    3,    2,    5,    3,    1,    2,    2,    4,    1,
    3,    3,    2,    3,    0,    2,    3,    4,    6,    6,
    1,    0,    5,    3,    1,    1,    3,    3,    2,    0,
    2,    1,    3,    5,    3,    6,    0,    2,    3,    3,
    1,    3,    2,    1,    1,    1,    1,    3,    3,    3,
    2,    2,    4,    2,    3,    0,    2,    3,    1,    3,
    4,    1,    0,    4,    1,    3,    1,    3,    1,    1,
    0,    8,    3,    0,    5,    0,    1,    0,    2,    2,
    2,    1,    3,    1,    3,    1,    4,    1,    3,    5,
    5,    1,    3,    3,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    9,    1,    0,    0,
    0,    0,    0,    0,    0,  164,    0,    0,    8,    0,
    0,    0,   97,   95,    0,    3,    0,    0,    0,    0,
    0,    0,    0,    0,   36,   38,    0,   39,    0,    0,
   37,    0,    0,    0,   54,  178,   52,   42,   53,    0,
    0,  173,   34,    0,    0,   32,   33,    0,    0,    0,
    0,  134,    0,  136,  137,  155,    0,  169,  160,  135,
    0,  163,    0,    0,    6,    0,    0,    0,    0,    0,
    0,   35,   60,    0,    0,    0,    0,   55,    0,    0,
    0,    4,    0,  167,    0,    0,    0,    0,  147,    0,
    0,  142,    0,  141,   16,   17,   18,   19,   25,   26,
   27,   28,   29,   30,   31,   22,   23,   24,   14,   15,
   20,   21,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  120,    0,    0,    0,    0,    0,    0,    0,
  171,    0,   67,   64,   69,   70,   71,   72,   73,   74,
   68,   66,  170,    0,  177,    0,    0,    0,    0,    0,
    0,  111,    0,    0,    0,    0,   61,    0,    0,    0,
    0,    0,  179,  165,    0,  152,    0,  138,    0,  148,
    0,    0,    0,  140,    0,    0,  158,   90,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  115,    0,    0,    0,  161,   89,   88,    0,  106,    0,
   98,    0,  133,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  175,
    0,    0,    0,    0,    0,    0,    0,   41,    0,    0,
   48,    0,    0,   63,  184,    0,   57,   56,  183,    0,
    0,  150,    0,    0,  143,    0,    0,    0,    0,   92,
    0,  120,  119,  118,  121,    0,    0,    0,    0,  125,
    0,   91,  107,    0,    0,    0,    0,    0,    0,    0,
    0,   84,   83,   85,    0,    0,    0,    0,    0,    0,
   81,   82,  132,    0,   11,    5,  181,  180,   43,    0,
    0,   46,    0,   58,  151,  145,  108,    0,    0,    0,
    0,  123,    0,    0,  114,  117,    0,    0,    0,    0,
    0,    0,    0,   99,    0,   50,    0,    0,    0,    0,
  113,  124,  128,    0,    0,    0,   94,    0,  104,   44,
  109,   65,  110,  126,    0,    0,  101,    0,  162,
};
short yydgoto[] = {                                       5,
   21,  123,  124,   61,  125,    6,    7,   45,   85,  202,
  142,  143,  144,   48,  145,  203,  146,  147,  148,  149,
  150,  100,   64,   65,   66,   67,   68,   17,   18,   30,
   72,  313,   90,  196,  197,  157,  240,  151,  277,  198,
   69,  152,   91,  183,   70,  320,  204,  162,  163,  175,
  176,   13,   19,    8,   93,   94,  171,   49,   74,  158,
  241,  242,   50,    9,  321,  199,  314,  271,   27,
};
short yysindex[] = {                                    -17,
   -4,    7, -297, -232,    0, -240,    0,    0, -224, -222,
 -219, -297, -276,   16,  -17,    0,   -1, -228,    0,   20,
 -230,   21,    0,    0,  288,    0,   24, -224,   86, -221,
 -203,   29,  -50,   28,    0,    0, -220,    0,   34, -197,
    0,  -30,  149,  187,    0,    0,    0,    0,    0,   37,
  313,    0,    0,   39,    0,    0,    0,  116,   12,   75,
  116,    0, 1270,    0,    0,    0,   38,    0,    0,    0,
  -40,    0,   42,   40,    0, -185,  -77, -184,   49,  -33,
   50,    0,    0,  212,   60,  -18,   61,    0,  -25,   66,
   19,    0,   72,    0,  116,   81,   50, 1130,    0,  384,
   -3,    0, 1359,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  116,  116,  116,  124,   49,  -15,  -54,   49,
   49,   49,    0,  250,   85,   49,   49,   49,  -14,   23,
    0,  922,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -203,    0,   62,   89,    2,   49, -142,
 -148,    0,  102, -128, -151,  313,    0, -126,  313,  313,
   55, -142,    0,    0,  108,    0,  116,    0,  116,    0,
  116,  116,   57,    0,  140, 1401,    0,    0,   49, -121,
 -120, -117, -129, 1027, 1001,   99, -221, -124,   86,   49,
    0, -228,  101, -244,    0,    0,    0,  954,    0,   51,
    0,  590,    0,   49,   49,   49,   49,   49,   49,   49,
   49,   49,   49,   49,   49,   49,   49,   49,   49,    0,
   49, -185,  133,   53,   61,   82, -107,    0,  118,  136,
    0,   56,  -89,    0,    0,  -25,    0,    0,    0,    0,
  143,    0, 1359, 1401,    0,  144,  146, -116,  148,    0,
  313,    0,    0,    0,    0, 1027, -221,  313,   49,    0,
  313,    0,    0,  -85,   49,   49,   98,  164,  164,  164,
  164,    0,    0,    0, 1442, 1442,  947, 1027,  164,  164,
    0,    0,    0, 1027,    0,    0,    0,    0,    0,   49,
 -128,    0,  -97,    0,    0,    0,    0,   49, -128,   49,
  -93,    0,  -92, -221,    0,    0, 1027,  154,  -99,  104,
  155,  986, 1027,    0, 1027,    0,  -72,  160,   77,  162,
    0,    0,    0,  -82, -228,   49,    0,  -85,    0,    0,
    0,    0,    0,    0, -221, 1027,    0,  -81,    0,
};
short yyrindex[] = {                                    -62,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -118,    0,    0,    9,    0,  -76,  -74,    0,  -75,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  176,    0,    0, 1301,    0,  408,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  177,    0,    0, 1458, 1420,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -69,    0,    0,    0,
    0,    0,   72,    0,    0,    0,    0,    0,  179,    0,
    0,    0,    0,    0,  -23,    0,  -31,    0,  128,  129,
    0,    0,    0,    0,  182, 1334, 1081,    0,    0,  -19,
    0,    0,  131,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  452,  506,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   83,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -24,  100,    0,    0,    0,
    0,    0,    0,  103,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  182,    0,    0,    0,
    0,    0,    0,    0, 1154,  -42,    0,    0,  179,    0,
    0,    0,    0, 1208,    0,  -60,    0,    0,    0,    0,
    0,  -74, -241,    0,    0,    0,    0,    0,    0,    0,
    0,  137,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  123,
    0,    0,    0,    0,    0,  128,    0,    0,    0, 1386,
    0,    0,  131,  156,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -37,    0,    0,    0,    0,
  177,    0,    0,    0,    0,    0,    0,  557,  674,  728,
  779,    0,    0,    0,  855,  880, 1232, 1259,  820,  833,
    0,    0,    0,  -20,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  179,  103,  179,
    0,    0,    0,    0,    0,    0,  -37,    0,    0,    0,
  161,  137,  172,    0,   -6,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -74,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   -9,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,  158,    0,  358,    0,
 1602,    0, 1580,  -21,    0,    0,    0,    0,    0,    0,
    0,  -28,    0,    0,    0,    0,   69,    0,    0, -196,
 -182,  -46,    0,    0,    0,    0,    0,    0,  -67,   15,
  165,    0, -133,   58,    0,    0, -245,  -59, -172,  132,
  -51,  281,  286,  300,   46,  -32,   88,    0,  175,  105,
   30,   27,    0,    0,    5,    0,    0,    0,    0,
};
#define YYTABLESIZE 1938
short yytable[] = {                                     138,
   63,  156,  136,  192,  137,  267,  309,  101,    2,   42,
   86,  153,   35,  160,  263,  311,  256,   62,  169,   12,
   81,  149,  316,   13,  189,  138,  236,    4,  136,   98,
  137,  103,  104,   12,  102,   10,   97,   51,  249,   14,
  269,  270,  190,  116,  116,  159,   11,   16,   15,   20,
  140,   58,   22,   24,   56,   25,   57,   28,   29,   31,
   32,   35,  138,   51,   33,  136,   71,  137,   73,   75,
  193,   77,   76,   79,   80,   78,  140,   92,   95,  210,
  155,  126,  139,  102,  315,  154,  156,  161,  138,  164,
  165,  136,   35,  137,  184,  185,  186,   63,  170,  234,
   12,   62,   60,  166,   13,  149,  167,  168,  139,  172,
  209,  173,  174,  140,   58,  211,   97,   56,   51,   57,
  177,  180,  231,  131,  205,   58,  233,  252,   56,  235,
   57,  333,  232,  244,   59,  328,   99,  330,  345,  140,
  237,  131,  238,  239,  243,  139,  245,  248,  250,  255,
  257,  258,  253,  254,  259,   58,  260,  262,   56,  268,
   57,  264,  348,   58,  299,   60,   56,  102,   57,  293,
   63,  139,  237,  296,  298,  273,   60,  297,  300,  301,
  302,  121,  303,  305,  307,  308,  122,  310,   42,  319,
  324,  327,  331,  332,  335,  336,  337,   59,  338,  340,
  341,  342,  343,  344,  349,  227,   60,  131,   59,    7,
  228,   96,  172,  168,   60,  176,   35,  166,  157,  112,
   59,  182,  153,  146,   10,  122,   42,   47,  141,  105,
  127,  128,   35,   36,  129,   38,  130,  131,   59,   84,
  132,  191,  133,  134,   37,  156,   59,   49,  144,   39,
  127,   42,  135,  100,  339,   40,  127,  128,   35,   36,
  129,   38,  130,  131,  103,   40,  132,  265,  133,  134,
  334,   43,    1,   83,    2,   39,  312,   84,  135,   88,
    7,   40,   53,   96,   35,   36,   37,   38,    3,   42,
  187,   41,   23,  127,  128,   35,   36,  129,   38,  130,
  131,   39,   84,  132,   88,  133,  134,   40,  251,   43,
  306,    3,   39,   52,   26,  135,  318,   41,   40,  127,
  128,   35,   36,  129,   38,  130,  131,   42,  230,  132,
  326,  133,  134,  304,   43,  329,  295,    0,   39,    0,
   84,  135,  347,   41,   40,   53,   96,   35,   36,   37,
   38,    0,   42,    0,   41,    0,   53,   54,   35,   36,
   37,   55,    0,    0,   39,    0,    0,  131,  131,    0,
   40,  131,   43,    0,    0,   39,    0,    0,   44,    0,
   41,   40,   46,    0,    0,    0,   53,   96,   35,   36,
   37,   38,    0,    0,   53,   54,   35,   36,   37,   38,
    0,   89,    0,   84,    0,   39,   41,  116,  117,  118,
   43,   40,    0,   39,    0,    0,    0,   41,    0,   40,
   82,   35,   36,   37,   38,  121,  119,  179,  120,    0,
  122,  218,  219,  220,    0,   43,    0,    0,   39,    0,
    0,   89,    0,    0,   40,    0,    0,   41,   40,   40,
   40,   40,   40,    0,   40,   41,    0,    0,   87,   35,
   36,   37,   38,    0,    0,    0,   40,    0,   40,    0,
    0,    0,    0,    0,    0,    0,   39,    0,    0,    0,
   41,    0,   40,   82,   35,   36,   37,   38,    0,    0,
    0,  201,   35,   35,   35,   35,   35,    0,   35,    0,
   40,   39,    0,    0,    0,    0,    0,   40,    0,    0,
   35,    0,   35,    0,    0,    0,    0,    0,   41,    0,
    0,   82,   35,   36,   37,   38,  246,  247,    0,    0,
    0,   40,   40,    0,  200,    0,    0,    0,    0,   39,
    0,    0,    0,   41,   35,   40,   45,   45,   45,   45,
   45,    0,   45,    0,    0,    0,    0,    0,    0,   34,
   35,   36,   37,   38,   45,    0,   45,    0,    0,    0,
    0,    0,    0,    0,    0,   35,   35,   39,    0,    0,
    0,   41,    0,   40,   82,   35,   36,   37,   38,    0,
    0,    0,    0,    0,    0,    0,    0,   77,   45,   77,
   77,   77,   39,    0,    0,    0,    0,    0,   40,    0,
    0,    0,    0,    0,    0,   77,    0,   77,  201,   41,
    0,    0,    0,    0,    0,  201,    0,    0,    0,   45,
   45,  227,  225,  275,  226,    0,  228,    0,    0,    0,
  105,  106,  107,  108,   41,    0,    0,    0,    0,   77,
  224,  116,  117,  118,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,    0,    0,
   77,   77,    0,    0,    0,    0,   40,   40,    0,   40,
    0,    0,   40,   40,   40,   40,   40,    0,    0,    0,
    0,   40,    0,    0,    0,    0,    0,   35,   35,   35,
   35,   35,    0,  276,   78,    0,   78,   78,   78,   35,
   35,   35,    0,    0,    0,    0,    0,    0,    0,    0,
   35,   35,   78,   35,   78,   40,   35,   35,    0,   35,
   35,    0,    0,    0,    0,   35,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   45,   45,   45,   45,   45,   78,    0,   79,    0,
   79,   79,   79,   45,   45,   45,    0,    0,    0,   35,
    0,    0,    0,    0,   45,   45,   79,   45,   79,    0,
   45,   45,    0,   45,   45,    0,    0,   78,   78,   45,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   77,   77,   77,   77,   77,    0,    0,   80,
   79,   80,   80,   80,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,   77,   77,   80,   77,   80,
    0,   77,   77,    0,   77,   77,  214,  215,  216,  217,
   77,   79,   79,    0,    0,    0,    0,  218,  219,  220,
   75,    0,   75,   75,   75,    0,    0,    0,  221,  222,
    0,   80,    0,   76,    0,   76,   76,   76,   75,    0,
   75,    0,    0,  274,   77,    0,    0,    0,    0,    0,
    0,   76,    0,   76,    0,   86,    0,    0,   86,    0,
    0,    0,   80,   80,    0,    0,    0,    0,    0,    0,
    0,    0,   75,   86,    0,   86,    0,  223,    0,    0,
   87,    0,    0,   87,    0,   76,    0,    0,    0,   78,
   78,   78,   78,   78,    0,    0,    0,    0,   87,    0,
   87,    0,    0,   75,   75,    0,    0,   86,    0,    0,
    0,    0,   78,   78,    0,   78,   76,   76,   78,   78,
    0,   78,   78,  227,  225,  229,  226,   78,  228,    0,
    0,    0,   87,    0,    0,    0,    0,    0,   86,   86,
    0,    0,  224,   79,   79,   79,   79,   79,  227,  225,
    0,  226,    0,  228,  272,  227,  225,    0,  226,    0,
  228,   78,    0,   87,   87,    0,   79,   79,    0,   79,
    0,    0,   79,   79,  224,   79,   79,    0,    0,    0,
    0,   79,    0,    0,    0,    0,    0,  227,  225,  275,
  226,    0,  228,    0,   80,   80,   80,   80,   80,    0,
    0,    0,  227,  225,    0,  226,  224,  228,    0,    0,
    0,    0,    0,    0,    0,   79,    0,   80,   80,    0,
   80,  224,    0,   80,   80,    0,   80,   80,  227,  225,
    0,  226,   80,  228,    0,   75,   75,   75,   75,   75,
    0,    0,    0,    0,    0,    0,    0,  224,   76,   76,
   76,   76,   76,    0,    0,    0,    0,    0,   75,   75,
    0,   75,    0,    0,   75,   75,   80,   75,   75,  276,
   86,   76,   76,   75,   76,    0,    0,   76,   76,    0,
   76,   76,   42,   42,    0,   42,   76,   42,    0,    0,
    0,    0,    0,   86,   86,   87,   86,    0,    0,   86,
   86,   42,   86,   86,    0,    0,    0,   75,   86,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   87,   87,
   76,   87,    0,    0,   87,   87,    0,   87,   87,    0,
  178,  121,  119,   87,  120,    0,  122,  213,  214,  215,
  216,  217,   86,    0,    0,    0,    0,    0,    0,  218,
  219,  220,    0,    0,  139,    0,  139,  139,  139,    0,
  221,  222,    0,  214,  215,  216,  217,   87,    0,    0,
  214,  215,  216,  217,  218,  219,  220,    0,    0,    0,
    0,  218,  219,  220,    0,  221,  222,    0,    0,    0,
    0,    0,  221,  222,    0,    0,    0,    0,    0,    0,
    0,    0,  214,  215,  216,  217,  139,    0,   93,  223,
    0,   93,    0,  218,  219,  220,    0,  214,  215,  216,
  217,    0,    0,    0,  221,  222,   93,    0,  218,  219,
  220,    0,  130,    0,  223,  130,    0,  139,  139,  221,
  222,  223,  261,  214,  215,  216,  217,    0,    0,    0,
  130,    0,  130,    0,  218,  219,  220,    0,    0,  129,
   93,    0,  129,    0,    0,  221,  222,    0,    0,    0,
    0,  121,  119,  223,  120,    0,  122,  129,    0,    0,
    0,    0,    0,    0,  130,    0,    0,    0,  223,    0,
    0,   93,   93,    0,    0,    0,    0,   42,   42,   42,
   42,   45,   45,   45,   45,   45,    0,   45,   42,   42,
   42,  129,    0,    0,  223,  130,  130,    0,    0,   42,
   42,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   35,   35,   35,   35,   35,    0,
   35,    0,  129,  129,    0,    0,  105,  106,  107,  108,
    0,    0,    0,   45,    0,    0,    0,  116,  117,  118,
  121,  119,  181,  120,    0,  122,    0,    0,   42,    0,
  139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
  139,    0,    0,    0,   45,   45,   35,  151,  151,  154,
  151,    0,  151,    0,    0,    0,    0,    0,    0,    0,
    0,  139,  121,  119,    0,  120,    0,  122,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   35,   35,    0,
    0,   39,   39,   93,   39,    0,   39,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  182,  227,  225,    0,  226,  130,  228,   93,
    0,    0,   93,   93,    0,   93,   93,    0,    0,   35,
   35,   93,   35,    0,   35,    0,    0,    0,    0,    0,
    0,    0,    0,  130,  129,    0,  130,  130,    0,  130,
  130,    0,    0,    0,    0,  130,  105,  106,  107,  108,
  109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  129,    0,    0,  129,  129,    0,  129,  129,    0,    0,
    0,    0,  129,    0,    0,    0,    0,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,   45,    0,
   35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
   35,   35,   35,   35,   47,    0,    0,    0,   62,    0,
    0,    0,    0,    0,    0,  105,  106,  107,  108,    0,
    0,   35,   47,   47,    0,    0,  116,  117,  118,    0,
   47,    0,    0,    0,    0,    0,    0,   62,   62,   62,
   62,    0,  151,  151,  151,  151,  151,  151,  151,  151,
  151,  151,  151,  151,  151,  151,    0,  105,  106,  107,
  108,    0,    0,   47,    0,    0,    0,    0,  116,  117,
  118,    0,    0,  154,   62,    0,   39,   39,   39,   39,
   39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
    0,    0,    0,    0,    0,    0,    0,    0,  214,  215,
  216,  217,   62,   62,   62,   62,    0,  159,    0,  218,
  219,  220,    0,   47,   35,   35,   35,   35,   35,   35,
   35,   35,   35,   35,   35,   35,   35,   35,  188,    0,
    0,    0,  194,  195,    0,    0,    0,  206,  207,  208,
    0,  212,    0,    0,    0,   47,    0,    0,   47,   47,
    0,    0,    0,    0,    0,    0,   62,    0,   62,    0,
   62,   62,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   62,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  266,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
    0,    0,  294,    0,    0,    0,    0,    0,    0,    0,
   47,    0,    0,    0,    0,    0,    0,   47,    0,    0,
   47,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  317,    0,    0,    0,    0,    0,  322,  323,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  325,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  346,
};
short yycheck[] = {                                      40,
   29,   44,   43,   58,   45,  202,  123,   59,    0,   40,
   43,   71,   44,   91,  197,  261,  189,   41,   44,   44,
   42,   41,  268,   44,   40,   40,  160,   45,   43,   58,
   45,   60,   61,  331,   44,   40,   58,   44,  172,  272,
  285,  286,   58,  285,  286,  123,   40,  272,  289,  272,
   91,   40,  272,  330,   43,   40,   45,   59,  287,   40,
  291,   93,   40,   40,   44,   43,  288,   45,  272,   41,
  130,   44,  123,   40,  272,  296,   91,   41,   40,  139,
   41,   44,  123,   93,  267,   44,  272,  272,   40,  123,
   41,   43,  124,   45,  123,  124,  125,  126,  124,  159,
  125,  125,   91,   44,  125,  125,  125,   47,  123,   44,
  125,   93,   41,   91,   40,   93,  138,   43,  125,   45,
   40,  125,   61,   41,   40,   40,  125,  179,   43,  272,
   45,  314,   44,  166,  123,  308,  125,  310,  335,   91,
  289,   59,   41,  272,  296,  123,  273,   93,   41,   93,
  272,  272,  181,  182,  272,   40,  286,   59,   43,   59,
   45,  286,  345,   40,  272,   91,   43,   93,   45,  229,
  199,  123,  289,   41,   93,  125,   91,  125,   61,   44,
  125,   42,  272,   41,   41,   40,   47,   40,   40,  275,
   93,  289,  286,  286,   41,  295,   93,  123,   44,  272,
   41,  125,   41,  286,  286,   42,   91,  125,  123,  272,
   47,  330,  289,  288,   91,  291,   41,   41,  288,   41,
   93,   93,   41,   93,  125,  286,   40,  125,   71,   93,
  271,  272,  273,  274,  275,  276,  277,  278,  123,   91,
  281,  296,  283,  284,  275,  288,  123,  125,   93,  290,
  288,   40,  293,   93,  322,  296,  271,  272,  273,  274,
  275,  276,  277,  278,   93,  296,  281,  199,  283,  284,
  317,  123,  290,  125,  292,  290,  262,   91,  293,   93,
  272,  296,  271,  272,  273,  274,  275,  276,  329,   40,
  126,  332,   12,  271,  272,  273,  274,  275,  276,  277,
  278,  290,   91,  281,   93,  283,  284,  296,  177,  123,
  253,  329,  290,   28,   15,  293,  271,  332,  296,  271,
  272,  273,  274,  275,  276,  277,  278,   40,  154,  281,
  301,  283,  284,  246,  123,  309,  232,   -1,  290,   -1,
   91,  293,  338,  332,  296,  271,  272,  273,  274,  275,
  276,   -1,   40,   -1,  332,   -1,  271,  272,  273,  274,
  275,  276,   -1,   -1,  290,   -1,   -1,  285,  286,   -1,
  296,  289,  123,   -1,   -1,  290,   -1,   -1,   91,   -1,
  332,  296,   25,   -1,   -1,   -1,  271,  272,  273,  274,
  275,  276,   -1,   -1,  271,  272,  273,  274,  275,  276,
   -1,   44,   -1,   91,   -1,  290,  332,  268,  269,  270,
  123,  296,   -1,  290,   -1,   -1,   -1,  332,   -1,  296,
  272,  273,  274,  275,  276,   42,   43,   44,   45,   -1,
   47,  268,  269,  270,   -1,  123,   -1,   -1,  290,   -1,
   -1,   84,   -1,   -1,  296,   -1,   -1,  332,   41,   42,
   43,   44,   45,   -1,   47,  332,   -1,   -1,  272,  273,
  274,  275,  276,   -1,   -1,   -1,   59,   -1,   61,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,   -1,   -1,   -1,
  332,   -1,  296,  272,  273,  274,  275,  276,   -1,   -1,
   -1,  134,   41,   42,   43,   44,   45,   -1,   47,   -1,
   93,  290,   -1,   -1,   -1,   -1,   -1,  296,   -1,   -1,
   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,  332,   -1,
   -1,  272,  273,  274,  275,  276,  169,  170,   -1,   -1,
   -1,  124,  125,   -1,  285,   -1,   -1,   -1,   -1,  290,
   -1,   -1,   -1,  332,   93,  296,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,  272,
  273,  274,  275,  276,   59,   -1,   61,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,  125,  290,   -1,   -1,
   -1,  332,   -1,  296,  272,  273,  274,  275,  276,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   93,   43,
   44,   45,  290,   -1,   -1,   -1,   -1,   -1,  296,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   61,  261,  332,
   -1,   -1,   -1,   -1,   -1,  268,   -1,   -1,   -1,  124,
  125,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
  257,  258,  259,  260,  332,   -1,   -1,   -1,   -1,   93,
   61,  268,  269,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,   -1,   -1,
  124,  125,   -1,   -1,   -1,   -1,  279,  280,   -1,  282,
   -1,   -1,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,  294,   -1,   -1,   -1,   -1,   -1,  256,  257,  258,
  259,  260,   -1,  124,   41,   -1,   43,   44,   45,  268,
  269,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  279,  280,   59,  282,   61,  328,  285,  286,   -1,  288,
  289,   -1,   -1,   -1,   -1,  294,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,  257,  258,  259,  260,   93,   -1,   41,   -1,
   43,   44,   45,  268,  269,  270,   -1,   -1,   -1,  328,
   -1,   -1,   -1,   -1,  279,  280,   59,  282,   61,   -1,
  285,  286,   -1,  288,  289,   -1,   -1,  124,  125,  294,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,  258,  259,  260,   -1,   -1,   41,
   93,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  328,   -1,  279,  280,   59,  282,   61,
   -1,  285,  286,   -1,  288,  289,  257,  258,  259,  260,
  294,  124,  125,   -1,   -1,   -1,   -1,  268,  269,  270,
   41,   -1,   43,   44,   45,   -1,   -1,   -1,  279,  280,
   -1,   93,   -1,   41,   -1,   43,   44,   45,   59,   -1,
   61,   -1,   -1,  294,  328,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   61,   -1,   41,   -1,   -1,   44,   -1,
   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   59,   -1,   61,   -1,  328,   -1,   -1,
   41,   -1,   -1,   44,   -1,   93,   -1,   -1,   -1,  256,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,   59,   -1,
   61,   -1,   -1,  124,  125,   -1,   -1,   93,   -1,   -1,
   -1,   -1,  279,  280,   -1,  282,  124,  125,  285,  286,
   -1,  288,  289,   42,   43,   44,   45,  294,   47,   -1,
   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,  124,  125,
   -1,   -1,   61,  256,  257,  258,  259,  260,   42,   43,
   -1,   45,   -1,   47,   41,   42,   43,   -1,   45,   -1,
   47,  328,   -1,  124,  125,   -1,  279,  280,   -1,  282,
   -1,   -1,  285,  286,   61,  288,  289,   -1,   -1,   -1,
   -1,  294,   -1,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,  256,  257,  258,  259,  260,   -1,
   -1,   -1,   42,   43,   -1,   45,   61,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  328,   -1,  279,  280,   -1,
  282,   61,   -1,  285,  286,   -1,  288,  289,   42,   43,
   -1,   45,  294,   47,   -1,  256,  257,  258,  259,  260,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   61,  256,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,   -1,  279,  280,
   -1,  282,   -1,   -1,  285,  286,  328,  288,  289,  124,
  256,  279,  280,  294,  282,   -1,   -1,  285,  286,   -1,
  288,  289,   42,   43,   -1,   45,  294,   47,   -1,   -1,
   -1,   -1,   -1,  279,  280,  256,  282,   -1,   -1,  285,
  286,   61,  288,  289,   -1,   -1,   -1,  328,  294,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  279,  280,
  328,  282,   -1,   -1,  285,  286,   -1,  288,  289,   -1,
   41,   42,   43,  294,   45,   -1,   47,  256,  257,  258,
  259,  260,  328,   -1,   -1,   -1,   -1,   -1,   -1,  268,
  269,  270,   -1,   -1,   41,   -1,   43,   44,   45,   -1,
  279,  280,   -1,  257,  258,  259,  260,  328,   -1,   -1,
  257,  258,  259,  260,  268,  269,  270,   -1,   -1,   -1,
   -1,  268,  269,  270,   -1,  279,  280,   -1,   -1,   -1,
   -1,   -1,  279,  280,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,   93,   -1,   41,  328,
   -1,   44,   -1,  268,  269,  270,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,  279,  280,   59,   -1,  268,  269,
  270,   -1,   41,   -1,  328,   44,   -1,  124,  125,  279,
  280,  328,  282,  257,  258,  259,  260,   -1,   -1,   -1,
   59,   -1,   61,   -1,  268,  269,  270,   -1,   -1,   41,
   93,   -1,   44,   -1,   -1,  279,  280,   -1,   -1,   -1,
   -1,   42,   43,  328,   45,   -1,   47,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,  328,   -1,
   -1,  124,  125,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   41,   42,   43,   44,   45,   -1,   47,  268,  269,
  270,   93,   -1,   -1,  328,  124,  125,   -1,   -1,  279,
  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,   -1,
   47,   -1,  124,  125,   -1,   -1,  257,  258,  259,  260,
   -1,   -1,   -1,   93,   -1,   -1,   -1,  268,  269,  270,
   42,   43,   44,   45,   -1,   47,   -1,   -1,  328,   -1,
  257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
  267,   -1,   -1,   -1,  124,  125,   93,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  288,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,
   -1,   42,   43,  256,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,   42,   43,   -1,   45,  256,   47,  282,
   -1,   -1,  285,  286,   -1,  288,  289,   -1,   -1,   42,
   43,  294,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  282,  256,   -1,  285,  286,   -1,  288,
  289,   -1,   -1,   -1,   -1,  294,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  282,   -1,   -1,  285,  286,   -1,  288,  289,   -1,   -1,
   -1,   -1,  294,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  287,  288,   -1,
  257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
  267,  268,  269,  270,   25,   -1,   -1,   -1,   29,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,  288,   43,   44,   -1,   -1,  268,  269,  270,   -1,
   51,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   -1,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,   -1,  257,  258,  259,
  260,   -1,   -1,   84,   -1,   -1,   -1,   -1,  268,  269,
  270,   -1,   -1,  288,   95,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,  123,  124,  125,  126,   -1,  288,   -1,  268,
  269,  270,   -1,  134,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  127,   -1,
   -1,   -1,  131,  132,   -1,   -1,   -1,  136,  137,  138,
   -1,  140,   -1,   -1,   -1,  166,   -1,   -1,  169,  170,
   -1,   -1,   -1,   -1,   -1,   -1,  177,   -1,  179,   -1,
  181,  182,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  199,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  200,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,  226,  227,  228,
   -1,   -1,  231,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  261,   -1,   -1,   -1,   -1,   -1,   -1,  268,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  269,   -1,   -1,   -1,   -1,   -1,  275,  276,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  300,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
};
#define YYFINAL 5
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 341
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,0,0,0,0,
0,"':'","';'",0,"'='",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",
"'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_bor","T_bxor","T_bsl","T_bsr","T_equal",
"T_notequal","T_le","T_lt","T_ge","T_gt","T_exactequal","T_div","T_rem",
"T_band","T_bnot","T_atom","T_number","T_string","T_var","T_bool","T_begin",
"T_catch","T_concat","T_listsub","T_case","T_of","T_if","T_receive","T_after",
"T_end","T_when","T_arrow","T_dot","T_define","T_defbody","T_record","T_fun",
"T_such","T_generator","T_rechash","T_form","T_plus","T_minus","T_multiply",
"T_divide","T_idiv","T_exprtail","T_patternlist","T_patterntail","T_pattern",
"T_tuple","T_bracket","T_exprs","T_list","T_funcall","T_remotefuncall",
"T_ifclause","T_match","T_many","T_guardtail","T_guardcall","T_biftest",
"T_guardtest","T_guardtests","T_funcclause","T_clausehead","T_clausebody",
"T_farity","T_attribute","T_patterntuple","T_function","T_send","T_pragma",
"T_endpragma","T_text","T_real","CATCH","SEND_OP","COMP_OP","LIST_OP","ADD_OP",
"MULT_OP","UNARY","UPLUS","UMINUS",
};
char *yyrule[] = {
"$accept : program",
"program : form_list",
"form_list : form T_dot",
"form_list : form T_dot form_list",
"form : '-' T_atom '(' attribute ')'",
"form : T_record '(' T_atom ',' '{' record_fields '}' ')'",
"form : T_define '(' def_clause T_defbody ')'",
"$$1 :",
"form : $$1 function",
"form : pragma",
"record_fields : record_field",
"record_fields : record_field ',' record_fields",
"record_field : T_atom",
"record_field : T_atom '=' expr",
"add_op : '+'",
"add_op : '-'",
"add_op : T_bor",
"add_op : T_bxor",
"add_op : T_bsl",
"add_op : T_bsr",
"mult_op : '*'",
"mult_op : '/'",
"mult_op : T_div",
"mult_op : T_rem",
"mult_op : T_band",
"comp_op : T_equal",
"comp_op : T_notequal",
"comp_op : T_le",
"comp_op : T_lt",
"comp_op : T_ge",
"comp_op : T_gt",
"comp_op : T_exactequal",
"prefix_op : '+'",
"prefix_op : '-'",
"prefix_op : T_bnot",
"basic_type : T_atom",
"basic_type : T_number",
"basic_type : T_real",
"basic_type : T_string",
"basic_type : T_bool",
"basic_type : T_define",
"basic_type : T_define '(' parameter_list ')'",
"basic_type : record_expr",
"record_expr : T_var T_rechash T_atom T_dot T_atom",
"record_expr : '(' record_expr ')' T_rechash T_atom T_dot T_atom",
"record_expr : T_var",
"record_expr : T_rechash T_atom '{' possible_basic_fields '}'",
"possible_basic_fields :",
"possible_basic_fields : basic_fields",
"basic_fields : basic_field",
"basic_fields : basic_field ',' basic_fields",
"basic_field : T_atom '=' expr",
"pattern : basic_type",
"pattern : pattern_list",
"pattern : pattern_tuple",
"pattern_list : '[' ']'",
"pattern_list : '[' pattern pattern_tail ']'",
"pattern_tail : '|' pattern",
"pattern_tail : ',' pattern pattern_tail",
"pattern_tail :",
"pattern_tuple : '{' '}'",
"pattern_tuple : '{' patterns '}'",
"patterns : pattern",
"patterns : pattern ',' patterns",
"expr : basic_type",
"expr : T_var T_rechash T_atom '{' possible_basic_fields '}'",
"expr : list",
"expr : tuple",
"expr : anon_function",
"expr : function_call",
"expr : case_expr",
"expr : if_expr",
"expr : receive_expr",
"expr : match_expr",
"expr : send_expr",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr T_bor expr",
"expr : expr T_bxor expr",
"expr : expr T_bsl expr",
"expr : expr T_bsr expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr T_rem expr",
"expr : expr T_div expr",
"expr : expr T_band expr",
"expr : expr T_concat expr",
"expr : expr T_listsub expr",
"expr : '-' expr",
"expr : '+' expr",
"expr : T_bnot expr",
"expr : '(' expr ')'",
"expr : T_begin exprs T_end",
"expr : T_catch expr",
"expr : '[' expr T_such list_comp_elements ']'",
"pragma : T_pragma pragma_text T_endpragma",
"pragma_text : T_text",
"pragma_text : T_text pragma_text",
"list : '[' ']'",
"list : '[' expr expr_tail ']'",
"list_comp_elements : list_comp_element",
"list_comp_elements : list_comp_element ',' list_comp_element",
"list_comp_element : T_var T_generator expr",
"expr_tail : '|' expr",
"expr_tail : ',' expr expr_tail",
"expr_tail :",
"tuple : '{' '}'",
"tuple : '{' exprs '}'",
"function_call : T_atom '(' parameter_list ')'",
"function_call : T_atom ':' T_atom '(' parameter_list ')'",
"function_call : T_var ':' T_atom '(' parameter_list ')'",
"parameter_list : exprs",
"parameter_list :",
"case_expr : T_case expr T_of cr_clauses T_end",
"cr_clause : cr_head clause_guard clause_body",
"cr_head : pattern",
"cr_clauses : cr_clause",
"cr_clauses : cr_clause ';' cr_clauses",
"if_expr : T_if if_clauses T_end",
"if_clause : if_head clause_body",
"$$2 :",
"if_head : $$2 guard",
"if_clauses : if_clause",
"if_clauses : if_clause ';' if_clauses",
"receive_expr : T_receive T_after expr receive_body T_end",
"receive_expr : T_receive cr_clauses T_end",
"receive_expr : T_receive cr_clauses T_after expr receive_body T_end",
"$$3 :",
"receive_body : $$3 clause_body",
"match_expr : expr '=' expr",
"send_expr : expr T_send expr",
"exprs : expr",
"exprs : expr ',' exprs",
"exprs : expr error",
"guard_expr : basic_type",
"guard_expr : guard_expr_list",
"guard_expr : guard_expr_tuple",
"guard_expr : guard_call",
"guard_expr : '(' guard_expr ')'",
"guard_expr : guard_expr add_op guard_expr",
"guard_expr : guard_expr mult_op guard_expr",
"guard_expr : prefix_op guard_expr",
"guard_expr_list : '[' ']'",
"guard_expr_list : '[' guard_expr guard_expr_tail ']'",
"guard_expr_tail : '|' guard_expr",
"guard_expr_tail : ',' guard_expr guard_expr_tail",
"guard_expr_tail :",
"guard_expr_tuple : '{' '}'",
"guard_expr_tuple : '{' guard_exprs '}'",
"guard_exprs : guard_expr",
"guard_exprs : guard_expr ',' guard_exprs",
"guard_call : T_atom '(' guard_parameter_list ')'",
"guard_parameter_list : guard_exprs",
"guard_parameter_list :",
"bif_test : T_atom '(' guard_parameter_list ')'",
"guard_test : bif_test",
"guard_test : guard_expr comp_op guard_expr",
"guard_tests : guard_test",
"guard_tests : guard_test ',' guard_tests",
"guard : T_bool",
"guard : guard_tests",
"$$4 :",
"anon_function : T_fun '(' $$4 formal_parameter_list ')' clause_guard clause_body T_end",
"function_clause : clause_head clause_guard clause_body",
"$$5 :",
"clause_head : T_atom $$5 '(' formal_parameter_list ')'",
"formal_parameter_list :",
"formal_parameter_list : patterns",
"clause_guard :",
"clause_guard : T_when guard",
"clause_body : T_arrow exprs",
"clause_body : T_arrow pragma",
"function : function_clause",
"function : function_clause ';' function",
"def_params : T_atom",
"def_params : T_atom ',' def_params",
"def_clause : T_atom",
"def_clause : T_atom '(' def_params ')'",
"attribute : pattern",
"attribute : '[' farity_list ']'",
"attribute : T_atom ',' '[' farity_list ']'",
"attribute : T_atom ',' '{' exprs '}'",
"farity_list : farity",
"farity_list : farity ',' farity_list",
"farity : T_atom '/' T_number",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1485 "erlang.y"

void yyerror(const char *s)
{
	yyerrorf(s);
}

int yyerrorf(const char *fmt, ...)
{
    char buff[1024];
    va_list args;

    va_start(args, fmt);
    vsprintf(buff, fmt, args);
    va_end(args);
    fputs(buff, stderr);
    fprintf(stderr, " in %s at line %d\n", current_file, current_line);
	fprintf(stderr, "yytext(%s)\n", yytext);
	yy_program->errors++;
	return 0;
}

#line 1012 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 144 "erlang.y"
{ 	
		yy_program->ast = yyvsp[0].formlist; 
	}
break;
case 2:
#line 149 "erlang.y"
{	
		yyval.formlist = new FormList(yyvsp[-1].node);
		yyval.formlist->set_program(yy_program);
        yyval.formlist->type(LT_number);
	}
break;
case 3:
#line 155 "erlang.y"
{ 	
		yyvsp[0].formlist->prepend(yyvsp[-2].node);
		yyval.formlist = yyvsp[0].formlist;	
	}
break;
case 4:
#line 161 "erlang.y"
{ 	
        if (*(yyvsp[-3].stringp) == "module")
        {
/*          printf("module value:%s\n", ((Form *)(*i))->value->emit_code().chars());*/
            yy_program->set_module(yyvsp[-1].attribute->print());
        }
		else if (*(yyvsp[-3].stringp) == "import")
		{
            yy_program->add_imports(yyvsp[-1].attribute);
		}
		else if (*(yyvsp[-3].stringp) == "export")
		{
            yy_program->add_exports(yyvsp[-1].attribute);
		}
		yyval.node = new Form(yyvsp[-3].stringp, yyvsp[-1].attribute); 
        yyval.node->type(LT_number);
	}
break;
case 5:
#line 179 "erlang.y"
{
        if (debug)
            fprintf(stderr,"adding -record(%s, exprs)\n", (*yyvsp[-5].stringp).c_str());
        yy_program->add_record(*(yyvsp[-5].stringp), yyvsp[-2].nodelist);
        yyval.node = NULL;
    }
break;
case 6:
#line 186 "erlang.y"
{
        if (debug)
            fprintf(stderr,"adding -define(X, %s)\n", (*yyvsp[-1].stringp).c_str());
        yyvsp[-2].defclause->body(*yyvsp[-1].stringp);
        add_define(yyvsp[-2].defclause);
        yyval.node = NULL;
    }
break;
case 7:
#line 194 "erlang.y"
{
        active_function = new FunctionList(); 
    }
break;
case 8:
#line 198 "erlang.y"
{	 
		yyval.node = yyvsp[0].funclist;
		yyval.funclist->set_program(yy_program);
	}
break;
case 9:
#line 203 "erlang.y"
{
        yyval.node = yyvsp[0].node;
        yyval.node->type(LT_number);
    }
break;
case 10:
#line 210 "erlang.y"
{   
        yyval.nodelist = new NodeList(yyvsp[0].node); 
        yyval.nodelist->type(yyvsp[0].node->type());
    }
break;
case 11:
#line 215 "erlang.y"
{   
		yyvsp[0].nodelist->prepend(yyvsp[-2].node); 
        yyvsp[0].nodelist->type(yyvsp[-2].node->type() | yyvsp[0].nodelist->type());
		yyval.nodelist = yyvsp[0].nodelist;
    }
break;
case 12:
#line 223 "erlang.y"
{   
        yyval.node = new Field(*(yyvsp[0].stringp), NULL); 
        yyval.node->type(LT_all);
    }
break;
case 13:
#line 228 "erlang.y"
{   
        yyval.node = new Field(*(yyvsp[-2].stringp), yyvsp[0].node); 
        yyval.node->type(yyvsp[0].node->type());
    }
break;
case 14:
#line 234 "erlang.y"
{	yyval.stringp = new string("Eplus"); }
break;
case 15:
#line 236 "erlang.y"
{	yyval.stringp = new string("Eminus"); }
break;
case 16:
#line 238 "erlang.y"
{	yyval.stringp = new string("Ebor"); }
break;
case 17:
#line 240 "erlang.y"
{	yyval.stringp = new string("Ebxor"); }
break;
case 18:
#line 242 "erlang.y"
{	yyval.stringp = new string("Ebsl"); }
break;
case 19:
#line 244 "erlang.y"
{	yyval.stringp = new string("Ebsr"); }
break;
case 20:
#line 247 "erlang.y"
{	yyval.stringp = new string("Emultiply"); }
break;
case 21:
#line 249 "erlang.y"
{	yyval.stringp = new string("Edivide"); }
break;
case 22:
#line 251 "erlang.y"
{	yyval.stringp = new string("Ediv"); }
break;
case 23:
#line 253 "erlang.y"
{	yyval.stringp = new string("Erem"); }
break;
case 24:
#line 255 "erlang.y"
{	yyval.stringp = new string("Eband"); }
break;
case 25:
#line 258 "erlang.y"
{	yyval.stringp = new string("Eequal"); }
break;
case 26:
#line 260 "erlang.y"
{	yyval.stringp = new string("Enotequal"); }
break;
case 27:
#line 262 "erlang.y"
{	yyval.stringp = new string("Elessequal"); }
break;
case 28:
#line 264 "erlang.y"
{	yyval.stringp = new string("Elessthan"); }
break;
case 29:
#line 266 "erlang.y"
{	yyval.stringp = new string("Egreaterequal"); }
break;
case 30:
#line 268 "erlang.y"
{	yyval.stringp = new string("Egreaterthan"); }
break;
case 31:
#line 270 "erlang.y"
{	yyval.stringp = new string("Eexactequal"); }
break;
case 32:
#line 273 "erlang.y"
{	yyval.stringp = new string("Epreplus"); }
break;
case 33:
#line 275 "erlang.y"
{	yyval.stringp = new string("Epreminus"); }
break;
case 34:
#line 277 "erlang.y"
{	yyval.stringp = new string("Ebnot"); }
break;
case 35:
#line 280 "erlang.y"
{ 
        string s;

        if (CurrentTable != NULL)
        {
#ifdef _ALLOCS_H
		    s = CurrentTable->add_temp();
#endif
            yyval.node = new Atom(s, yyvsp[0].stringp); 
        }
        else
        {
            s = "__vvv";
            yyval.node = new Atom(s, yyvsp[0].stringp); 
        }
        yyval.node->type(LT_atom | LT_constant | LT_on_heap);
    }
break;
case 36:
#line 298 "erlang.y"
{ 
        yyval.node = new Number(yyvsp[0].number); 
        yyval.node->type(LT_number | LT_constant);
    }
break;
case 37:
#line 303 "erlang.y"
{ 
        yyval.node = new Real(*(yyvsp[0].stringp)); 
        yyval.node->type(LT_real | LT_constant);
    }
break;
case 38:
#line 308 "erlang.y"
{ 
        string s;

#ifdef _ALLOCS_H
        if (CurrentTable != NULL)
        {
		    s = CurrentTable->add_temp();
        }
#endif

        yyval.node = new Estring(s, yyvsp[0].stringp); 
        yyval.node->type(LT_list | LT_on_heap);
    }
break;
case 39:
#line 322 "erlang.y"
{ 
        yyval.node = new Boolean(yyvsp[0].number); 
        yyval.node->type(LT_bool | LT_constant);
    }
break;
case 40:
#line 327 "erlang.y"
{
        yyval.node = new Define(*(yyvsp[0].stringp));
    }
break;
case 41:
#line 331 "erlang.y"
{
        yyval.node = new Define(*(yyvsp[-3].stringp));
    }
break;
case 42:
#line 335 "erlang.y"
{
        yyval.node = yyvsp[0].node;
    }
break;
case 43:
#line 341 "erlang.y"
{
        yyval.node = new Record(new Variable(yyvsp[-4].stringp), *(yyvsp[-2].stringp), *(yyvsp[0].stringp)); 
        /*$$ = new Record($1, *($3), *($5)); */
        /*printf("blah#rec.x executed\n");*/
    }
break;
case 44:
#line 347 "erlang.y"
{
        yyval.node = new Record(yyvsp[-5].node, *(yyvsp[-2].stringp), *(yyvsp[0].stringp)); 
    }
break;
case 45:
#line 351 "erlang.y"
{ 
        Symbol * s = NULL;
        
        if (CurrentTable != NULL)
        { 
            s = CurrentTable->find(*(yyvsp[0].stringp), S_Variable);
        }

        if (s != NULL) 
        {
            yyval.node = s->associated();
            /* $$->type(s->type());*/
        }
        else
        {
            yyval.node = new Variable(yyvsp[0].stringp); 
            yyval.node->type(LT_normal);
        }
    }
break;
case 46:
#line 371 "erlang.y"
{
        yyval.node = new NewRecord(*(yyvsp[-3].stringp), yyvsp[-1].nodelist); 
    }
break;
case 47:
#line 377 "erlang.y"
{ yyval.nodelist = NULL; }
break;
case 48:
#line 379 "erlang.y"
{ yyval.nodelist = yyvsp[0].nodelist; }
break;
case 49:
#line 383 "erlang.y"
{   
        yyval.nodelist = new NodeList(yyvsp[0].node); 
        yyval.nodelist->type(yyvsp[0].node->type());
    }
break;
case 50:
#line 388 "erlang.y"
{   
		yyvsp[0].nodelist->prepend(yyvsp[-2].node); 
        yyvsp[0].nodelist->type(yyvsp[-2].node->type() | yyvsp[0].nodelist->type());
		yyval.nodelist = yyvsp[0].nodelist;
    }
break;
case 51:
#line 396 "erlang.y"
{   
        yyval.node = new Field(*(yyvsp[-2].stringp), yyvsp[0].node); 
        yyval.node->type(yyvsp[0].node->type());
    }
break;
case 52:
#line 402 "erlang.y"
{ yyval.node = yyvsp[0].node; }
break;
case 53:
#line 404 "erlang.y"
{ yyval.node = yyvsp[0].nodelist; }
break;
case 54:
#line 406 "erlang.y"
{ 
        yyval.node = yyvsp[0].node; 
        yyval.node->type(yyvsp[0].node->type() & ~LT_on_heap);
    }
break;
case 55:
#line 412 "erlang.y"
{ yyval.nodelist = new PatternTail; }
break;
case 56:
#line 414 "erlang.y"
{ 
		yyvsp[-1].nodelist->prepend(yyvsp[-2].node);
		yyval.nodelist = yyvsp[-1].nodelist;
	}
break;
case 57:
#line 420 "erlang.y"
{ 	
        yyval.nodelist = new PatternTail(yyvsp[0].node); 
        /*$2->type($2->type() | LT_on_heap);*/
        yyvsp[0].node->type(yyvsp[0].node->type() & ~LT_on_heap);
    }
break;
case 58:
#line 426 "erlang.y"
{ 	
		yyvsp[0].nodelist->prepend(yyvsp[-1].node); 
		yyval.nodelist = yyvsp[0].nodelist;
	}
break;
case 59:
#line 431 "erlang.y"
{	yyval.nodelist = new PatternTail; }
break;
case 60:
#line 434 "erlang.y"
{ 
        string s;

        if (CurrentTable != NULL)
        {
		    s = CurrentTable->add_temp();
        }
        yyval.node = new PatternTuple(s); 
    }
break;
case 61:
#line 444 "erlang.y"
{ 
        string s;

        if (CurrentTable != NULL)
        {
		    s = CurrentTable->add_temp();
        }
        yyval.node = new PatternTuple(s, yyvsp[-1].nodelist); 
        yyval.node->type(LT_normal);
    }
break;
case 62:
#line 456 "erlang.y"
{ yyval.nodelist = new PatternList(yyvsp[0].node); }
break;
case 63:
#line 458 "erlang.y"
{ 
		yyvsp[0].nodelist->prepend(yyvsp[-2].node); 
		yyval.nodelist = yyvsp[0].nodelist;
	}
break;
case 64:
#line 465 "erlang.y"
{   yyval.node = yyvsp[0].node; }
break;
case 65:
#line 467 "erlang.y"
{
        yyval.node = new NewRecord(*(yyvsp[-5].stringp), *(yyvsp[-3].stringp), yyvsp[-1].nodelist); 
    }
break;
case 66:
#line 471 "erlang.y"
{	
        yyval.node = yyvsp[0].nodelist; 
        yyval.node->type(LT_list | LT_on_heap);
    }
break;
case 67:
#line 476 "erlang.y"
{	
        yyval.node = yyvsp[0].node; 
        yyval.node->type(LT_tuple | LT_on_heap);
    }
break;
case 68:
#line 481 "erlang.y"
{
        yyval.node = yyvsp[0].node;
        yyval.node->type(LT_anyvar);
    }
break;
case 69:
#line 486 "erlang.y"
{	
        yyval.node = yyvsp[0].node; 
        yyval.node->type(yyvsp[0].node->type() | LT_on_heap);
    }
break;
case 70:
#line 491 "erlang.y"
{ yyval.node = yyvsp[0].node;  }
break;
case 71:
#line 493 "erlang.y"
{ yyval.node = yyvsp[0].node; }
break;
case 72:
#line 495 "erlang.y"
{ yyval.node = yyvsp[0].node; }
break;
case 73:
#line 497 "erlang.y"
{ yyval.node = yyvsp[0].node; }
break;
case 74:
#line 499 "erlang.y"
{ yyval.node = yyvsp[0].node; }
break;
case 75:
#line 501 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new PlusExpr(yyvsp[-2].node, yyvsp[0].node); 
        if ( ((yyvsp[-2].node->type() & LT_single) == LT_real) 
           ||((yyvsp[0].node->type() & LT_single) == LT_real) )
            yyval.node->type(LT_real);
        else if ( ((yyvsp[-2].node->type() & LT_single) == LT_number) 
           && ((yyvsp[0].node->type() & LT_single) == LT_number) )
            yyval.node->type(LT_number);
        else
            yyval.node->type(LT_number | LT_real);
    }
break;
case 76:
#line 515 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new MinusExpr(yyvsp[-2].node, yyvsp[0].node); 
        if ( ((yyvsp[-2].node->type() & LT_single) == LT_real) 
           || ((yyvsp[0].node->type() & LT_single) == LT_real) )
            yyval.node->type(LT_real);
        else if ( ((yyvsp[-2].node->type() & LT_single) == LT_number) 
           && ((yyvsp[0].node->type() & LT_single) == LT_number) )
            yyval.node->type(LT_number);
        else
            yyval.node->type(LT_number | LT_real);
    }
break;
case 77:
#line 529 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new BorExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_number);
    }
break;
case 78:
#line 536 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new BxorExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_number);
    }
break;
case 79:
#line 543 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new BslExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_number);
    }
break;
case 80:
#line 550 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new BsrExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_number);
    }
break;
case 81:
#line 557 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new MultiplyExpr(yyvsp[-2].node, yyvsp[0].node); 
        if ( ((yyvsp[-2].node->type() & LT_single) == LT_real) 
           ||((yyvsp[0].node->type() & LT_single) == LT_real) )
            yyval.node->type(LT_real);
        else if ( ((yyvsp[-2].node->type() & LT_single) == LT_number) 
           && ((yyvsp[0].node->type() & LT_single) == LT_number) )
            yyval.node->type(LT_number);
        else 
            yyval.node->type(LT_number | LT_real);
        
    }
break;
case 82:
#line 572 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new DivideExpr(yyvsp[-2].node, yyvsp[0].node); 
        if ( ((yyvsp[-2].node->type() & LT_single) == LT_real) 
           ||((yyvsp[0].node->type() & LT_single) == LT_real) )
            yyval.node->type(LT_real);
        else if ( ((yyvsp[-2].node->type() & LT_single) == LT_number) 
           && ((yyvsp[0].node->type() & LT_single) == LT_number) )
            yyval.node->type(LT_number);
        else 
            yyval.node->type(LT_number | LT_real);
    }
break;
case 83:
#line 586 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new RemExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_number);
    }
break;
case 84:
#line 593 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new DivExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_number);
    }
break;
case 85:
#line 600 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new BandExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_number);
    }
break;
case 86:
#line 607 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new ConcatExpr(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_list);
    }
break;
case 87:
#line 614 "erlang.y"
{
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
		yyval.node = new ListSubtract(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(LT_list);
    }
break;
case 88:
#line 621 "erlang.y"
{
        yyvsp[0].node->set_depth(1);
		yyval.node = new UnaryMinus(yyvsp[0].node); 
        yyval.node->type(yyvsp[0].node->type());
    }
break;
case 89:
#line 627 "erlang.y"
{
        yyvsp[0].node->set_depth(1);
		yyval.node = new UnaryPlus(yyvsp[0].node); 
        yyval.node->type(yyvsp[0].node->type());
    }
break;
case 90:
#line 633 "erlang.y"
{
        yyvsp[0].node->set_depth(1);
		yyval.node = new UnaryBnot(yyvsp[0].node); 
        yyval.node->type(yyvsp[0].node->type());
    }
break;
case 91:
#line 639 "erlang.y"
{ 
        yyval.node = new Bracket(yyvsp[-1].node); 
        yyval.node->type(yyvsp[-1].node->type());
    }
break;
case 92:
#line 644 "erlang.y"
{ 
        /* $2->delimiter(", ");*/
        yyvsp[-1].exprlist->set_depth(1);
        yyvsp[-1].exprlist->assign(retsymbol);
        yyval.node = yyvsp[-1].exprlist; 
        yyval.node->type(yyvsp[-1].exprlist->type());
    }
break;
case 93:
#line 652 "erlang.y"
{ 
        yyvsp[0].node->set_depth(1);
        yyval.node = new Catch(yyvsp[0].node); 
        /* $$->assign(retsymbol);*/
        yyval.node->type(yyvsp[0].node->type());
    }
break;
case 94:
#line 659 "erlang.y"
{
        yyval.node = new List_Comp(yyvsp[-3].node, yyvsp[-1].nodelist);
    }
break;
case 95:
#line 664 "erlang.y"
{ yyval.node = new Pragma(yyvsp[-1].exprlist); }
break;
case 96:
#line 667 "erlang.y"
{ 
        string s;

        yyval.exprlist = new ExprList(new Estring(s,yyvsp[0].stringp)); 
    }
break;
case 97:
#line 673 "erlang.y"
{ 
        string s;
        Estring * p = new Estring(s,yyvsp[-1].stringp);

        yyvsp[0].exprlist->prepend(p);
        yyval.exprlist = yyvsp[0].exprlist;
    }
break;
case 98:
#line 682 "erlang.y"
{	
        string s;

#ifdef _ALLOCS_H
        if (CurrentTable != NULL)
        {
		    s = CurrentTable->add_temp();
        }
#endif
        yyval.nodelist = new EList(s); 
        /* $$->type($$->type() | LT_on_heap);*/
    }
break;
case 99:
#line 695 "erlang.y"
{	
        yyvsp[-2].node->set_depth(1);
		yyvsp[-1].nodelist->prepend(yyvsp[-2].node);
        yyvsp[-1].nodelist->set_depth(1);
		yyval.nodelist = yyvsp[-1].nodelist;
        /* $$->type($$->type() | LT_on_heap);*/
	}
break;
case 103:
#line 712 "erlang.y"
{ 	
        string s, s1, s2, s3;

        if (CurrentTable != NULL)
        {
#ifdef _ALLOCS_H
		    s = CurrentTable->add_temp();
#endif
		    s1 = CurrentTable->add_temp();
		    s2 = CurrentTable->add_temp();
		    s3 = CurrentTable->add_temp();
        }
        yyvsp[0].node->set_depth(1);
        yyval.nodelist = new EList(s,s1,s2,s3,yyvsp[0].node); 
    }
break;
case 104:
#line 728 "erlang.y"
{ 	
        yyvsp[-1].node->set_depth(1);
		yyvsp[0].nodelist->prepend(yyvsp[-1].node);
		yyval.nodelist = yyvsp[0].nodelist;
	}
break;
case 105:
#line 734 "erlang.y"
{	
        string s;

        if (CurrentTable != NULL)
        {
#ifdef _ALLOCS_H
		    s = CurrentTable->add_temp();
#endif
        }
        yyval.nodelist = new EList(s); 
    }
break;
case 106:
#line 747 "erlang.y"
{	
        string s;

#ifdef _ALLOCS_H
        if (CurrentTable != NULL)
        {
		    s = CurrentTable->add_temp();
        }
#endif
        yyval.node = new Tuple(s); 
    }
break;
case 107:
#line 759 "erlang.y"
{	
        string s;

#ifdef _ALLOCS_H
        if (CurrentTable != NULL)
        {
		    s = CurrentTable->add_temp();
        }
#endif
        yyvsp[-1].exprlist->set_depth(1);
        yyval.node = new Tuple(s, yyvsp[-1].exprlist); 
    }
break;
case 108:
#line 773 "erlang.y"
{	
		string module;
        string fname = Namer::semi_mangle(*(yyvsp[-3].stringp),yyvsp[-1].exprlist->size());
        int x;
        string ts;
        Symbol * other, * freevar = NULL;
        /* SymbolTable * function_table;*/
        FunctionCall * fcall;

		/* Need to do some clever stuff in here with imported modules	*/
        if ( (other = yy_program->Table.find(fname, S_Function)) )
        {
            x = other->used();
            module = other->module();
            other->used(x+1);
        }

        if (module.length() == 0)
        {
		    module = yy_program->Module();
        }
#if 0
        fprintf(stderr, "CT->name() = %s_%d (%s:%s_%d)\n", 
            CurrentTable->name().c_str(), CurrentTable->params(),
            module.c_str(), (*(yyvsp[-3].stringp)).c_str(), yyvsp[-1].exprlist->size());
#endif
        if (CurrentTable == NULL)
        {
            yyval.node = NULL;
            break;
        }

        freevar = CurrentTable->add_freetemp();
		fcall = new FunctionCall(&module, yyvsp[-3].stringp, yyvsp[-1].exprlist, freevar); 
        fcall->scope(CurrentTable);

        /* need to find the Function symbol table */
        if ((module == yy_program->Module())
                && (CurrentTable->params() == yyvsp[-1].exprlist->size())
                && (CurrentTable->name() == (*(yyvsp[-3].stringp))))
        {
#if 0
            fprintf(stderr, "%s_%d setting LCO_localfun\n", (*(yyvsp[-3].stringp)).c_str(),
                    yyvsp[-1].exprlist->size());
#endif
            active_function->lco(true);
            fcall->LCO(LCO_localfun);
            fcall->stmt_type(ST_goto);
        }
        else if (module == yy_program->Module() || module == "bif" 
                 || module == "erlang")
        {
#if 0
            fprintf(stderr, "%s_%d setting LCO_local\n", (*(yyvsp[-3].stringp)).c_str(),
                    yyvsp[-1].exprlist->size());
#endif
            fcall->LCO(LCO_local);
        }
        yyval.node = fcall;
        yyval.node->line(current_line);
	}
break;
case 109:
#line 835 "erlang.y"
{	
        Symbol * freevar;

        FunctionCall * fcall;
        freevar = CurrentTable->add_freetemp();
        fcall = new FunctionCall(yyvsp[-5].stringp, yyvsp[-3].stringp, yyvsp[-1].exprlist, freevar); 
        fcall->scope(CurrentTable);
        fcall->LCO(LCO_external);
        yyval.node = fcall;
        yyval.node->line(current_line);

    }
break;
case 110:
#line 848 "erlang.y"
{	
        Symbol * freevar;

        FunctionCall * fcall;
        freevar = CurrentTable->add_freetemp();
        fcall = new FunctionCall(yyvsp[-5].stringp, yyvsp[-3].stringp, yyvsp[-1].exprlist, freevar); 
        fcall->scope(CurrentTable);
        fcall->LCO(LCO_external);
        yyval.node = fcall;
        yyval.node->line(current_line);

    }
break;
case 111:
#line 862 "erlang.y"
{	
        int i;
        string ts;
        Symbol * s;
        list<Node *>::iterator nit;

        yyvsp[0].exprlist->set_depth(1);
        yyvsp[0].exprlist->allocate_locals(tmp_val_count);
        for (i = 0, nit = yyvsp[0].exprlist->nodes.begin(); i < yyvsp[0].exprlist->size(); i++,nit++)
        {
 		    s = new Symbol("_vx" + itoa(tmp_val_count++), S_Variable, ts);
            /* FIX: should be ok - but it propogates*/
            /* s->type((*nit)->type());*/
            /* (*nit)->freesym(s));*/
		    CurrentTable->add(s);
        }
        yyval.exprlist = yyvsp[0].exprlist; 	
    }
break;
case 112:
#line 881 "erlang.y"
{	yyval.exprlist = new ExprList(); 	}
break;
case 113:
#line 884 "erlang.y"
{	
		string ts = "";
		string label;
		Symbol * s;
		Case * cs;
		cs = new Case(yyvsp[-3].node, yyvsp[-1].caselist);
        cs->assign(retsymbol);

		label = cs->label();
        if (debug) fprintf(stderr,"case(%s) at line %d\n", label.c_str(), current_line);
        assert(CurrentTable != NULL);

 		s = new Symbol(label, S_Variable, ts);
		CurrentTable->add(s);
 		s = new Symbol(label + "L", S_Boolean, ts);
		CurrentTable->add(s);

        yyvsp[-3].node->parent(cs);
        yyvsp[-1].caselist->set_depth(1);
        yyvsp[-1].caselist->set_parent(cs);

		yyval.node = cs;
        yyval.node->type(yyvsp[-1].caselist->type());
	}
break;
case 114:
#line 910 "erlang.y"
{	
		yyval.node = new CrClause(yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
        ((ClauseBody *)yyvsp[0].node)->scope(CurrentTable);
        TableStack.pop_front();
        CurrentTable = TableStack.front();
        yyvsp[-2].node->add_symbol(CurrentTable);
        yyval.node->type(yyvsp[0].node->type());
        /* $3->parent($1);*/
	}
break;
case 115:
#line 923 "erlang.y"
{
		SymbolTable * s;
		string chid;
		string ts = "";

		chid = "cH" + itoa(cr_id++);
 		s = new SymbolTable(chid, S_Clause, ts, 0);
        /* s->chain(CurrentTable);*/
        TableStack.push_front(s);
		CurrentTable = s;
		yyval.node = new CrHead(CurrentTable->symbol(),CurrentTable,yyvsp[0].node); 
        yyvsp[0].node->add_symbol(CurrentTable);
    }
break;
case 116:
#line 938 "erlang.y"
{	
        yyval.caselist = new CaseList(yyvsp[0].node); 
        yyval.caselist->type(yyvsp[0].node->type());
    }
break;
case 117:
#line 943 "erlang.y"
{	
		yyvsp[0].caselist->prepend(yyvsp[-2].node); 
		yyval.caselist = yyvsp[0].caselist;
        yyval.caselist->type(yyvsp[-2].node->type() | yyvsp[0].caselist->type());
	}
break;
case 118:
#line 950 "erlang.y"
{	
        yyval.node = new If(yyvsp[-1].nodelist); 
        yyval.node->type(yyvsp[-1].nodelist->type());

        string ts;
 		Symbol * ifsymbol = new Symbol("_ifval" + itoa(if_id++), S_Variable, ts);
        yyval.node->assign(ifsymbol);
        CurrentTable->add(ifsymbol);
    }
break;
case 119:
#line 961 "erlang.y"
{	
        yyval.node = new IfClause(yyvsp[-1].node, yyvsp[0].node); 
        yyvsp[0].node->set_depth(1);
        yyvsp[0].node->set_flat(true);
        yyval.node->type(yyvsp[0].node->type());
        /* $2->parent($$);*/
        ((ClauseBody *)yyvsp[0].node)->scope(CurrentTable);
        TableStack.pop_front();
        CurrentTable = TableStack.front();
    }
break;
case 120:
#line 973 "erlang.y"
{
    }
break;
case 121:
#line 976 "erlang.y"
{
		string ifid;
		string ts = "";
        SymbolTable * s;

		ifid = "iH" + itoa(cr_id++);
 		s = new SymbolTable(ifid, S_Clause, ts, 0);

        /* s->chain(CurrentTable);*/

        TableStack.push_front(s);
		CurrentTable = s;
        yyval.node = yyvsp[0].node;
    }
break;
case 122:
#line 992 "erlang.y"
{ 	
        yyval.nodelist = new NodeList(yyvsp[0].node); 
        yyval.nodelist->type(yyvsp[0].node->type());
    }
break;
case 123:
#line 997 "erlang.y"
{	
		yyvsp[0].nodelist->prepend(yyvsp[-2].node); 
        yyvsp[0].nodelist->type(yyvsp[-2].node->type() | yyvsp[0].nodelist->type());
		yyval.nodelist = yyvsp[0].nodelist;
	}
break;
case 124:
#line 1004 "erlang.y"
{	
        Receive * r;
        string label, empty;
        Symbol * s;

        r = new Receive(NULL, yyvsp[-2].node, yyvsp[-1].node); 
        r->assign(retsymbol);
        label = r->label();
        if (CurrentTable)
        {
            s = new Symbol(label, S_Variable, empty);
            CurrentTable->add(s);
            s = new Symbol(label + "L", S_Boolean, empty);
            CurrentTable->add(s);
        }                          
        yyvsp[-1].node->set_depth(1);
        yyval.node = r;
        yyval.node->type(yyvsp[-1].node->type());
    }
break;
case 125:
#line 1024 "erlang.y"
{
        Receive * r;
        string label, empty;
        Symbol * s;

        r = new Receive(yyvsp[-1].caselist, NULL, NULL); 
        r->assign(retsymbol);
        label = r->label();
        if (CurrentTable)
        {
            s = new Symbol(label, S_Variable, empty);
            CurrentTable->add(s);
            s = new Symbol(label + "L", S_Boolean, empty);
            CurrentTable->add(s);
        }                          
        yyvsp[-1].caselist->set_depth(1);
        yyvsp[-1].caselist->set_parent(r);
        yyval.node = r;
        yyval.node->type(yyvsp[-1].caselist->type());
    }
break;
case 126:
#line 1045 "erlang.y"
{	
        Receive * r;
        string label, empty;
        Symbol * s;

        r = new Receive(yyvsp[-4].caselist, yyvsp[-2].node, yyvsp[-1].node); 
        r->assign(retsymbol);
        label = r->label();
        yyvsp[-2].node->add_symbol(CurrentTable);
        if (CurrentTable)
        {
            s = new Symbol(label, S_Variable, empty);
            CurrentTable->add(s);
            s = new Symbol(label + "L", S_Boolean, empty);
            CurrentTable->add(s);
        }                          
        yyvsp[-4].caselist->set_depth(1);
        yyvsp[-4].caselist->set_parent(r);
        yyvsp[-2].node->set_depth(1);
        yyvsp[-1].node->set_depth(1);
        yyval.node = r;
        yyval.node->type(yyvsp[-4].caselist->type() | yyvsp[-1].node->type());
    }
break;
case 127:
#line 1070 "erlang.y"
{
		string ifid;
		string ts = "";
        SymbolTable * s;

		ifid = "rH" + itoa(cr_id++);
 		s = new SymbolTable(ifid, S_Clause, ts, 0);

        TableStack.push_front(s);
		CurrentTable = s;
    }
break;
case 128:
#line 1082 "erlang.y"
{
        ((ClauseBody *)yyvsp[0].node)->scope(CurrentTable);
        TableStack.pop_front();
        CurrentTable = TableStack.front();
        yyval.node = yyvsp[0].node;
    }
break;
case 129:
#line 1091 "erlang.y"
{ 
        string ts = "";
        string label;
        Match * mtch;
        Symbol * s;

        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);

        /* Create a new "match" variable which is the RHS*/
        mtch = new Match(yyvsp[-2].node, yyvsp[0].node); 
		label = mtch->label();
 		s = new Symbol(label, S_Variable, ts);
		if (CurrentTable)
		{
			CurrentTable->add(s);
		}
        yyval.node = mtch;

        mtch->Table.chain(CurrentTable);

        /* Now add the symbols into the Matches symbol table.*/
        yyvsp[-2].node->add_symbol(&(mtch->Table), yyvsp[0].node->type() & LT_single);
        /* Now add all variables in LHS into the symbol table*/
        /* $1->add_symbol(CurrentTable, $3->type() & LT_single);*/

        yyval.node->type(yyvsp[0].node->type());
    }
break;
case 130:
#line 1121 "erlang.y"
{ 
        yyvsp[-2].node->set_depth(1);
        yyvsp[0].node->set_depth(1);
        yyval.node = new Send(yyvsp[-2].node, yyvsp[0].node); 
        yyval.node->type(yyvsp[0].node->type());
     }
break;
case 131:
#line 1129 "erlang.y"
{	
        yyvsp[0].node->line(current_line);
        yyval.exprlist = new ExprList(yyvsp[0].node); 
        yyval.exprlist->type(yyvsp[0].node->type());
        yyvsp[0].node->parent(yyval.exprlist);
    }
break;
case 132:
#line 1136 "erlang.y"
{	
        yyvsp[-2].node->line(current_line);
        yyvsp[-2].node->parent(yyvsp[0].exprlist);
		yyvsp[0].exprlist->prepend(yyvsp[-2].node);
		yyval.exprlist = yyvsp[0].exprlist; 
	}
break;
case 133:
#line 1143 "erlang.y"
{
        yyerrorf("Syntax error: expecting a `,' between expressions");
        return 0;
    }
break;
case 134:
#line 1149 "erlang.y"
{	yyval.node = yyvsp[0].node; }
break;
case 135:
#line 1151 "erlang.y"
{	yyval.node = yyvsp[0].nodelist; }
break;
case 136:
#line 1153 "erlang.y"
{	yyval.node = yyvsp[0].node; }
break;
case 137:
#line 1155 "erlang.y"
{	yyval.node = yyvsp[0].node; }
break;
case 138:
#line 1157 "erlang.y"
{	yyval.node = yyvsp[-1].node; }
break;
case 139:
#line 1159 "erlang.y"
{
		yyval.node = new Binary(yyvsp[-1].stringp, yyvsp[-2].node, yyvsp[0].node); 
		delete yyvsp[-1].stringp;
	}
break;
case 140:
#line 1164 "erlang.y"
{
		yyval.node = new Binary(yyvsp[-1].stringp, yyvsp[-2].node, yyvsp[0].node); 
		delete yyvsp[-1].stringp;
	}
break;
case 141:
#line 1169 "erlang.y"
{ 
		yyval.node = new Unary(yyvsp[-1].stringp, yyvsp[0].node); 
		delete yyvsp[-1].stringp;
	}
break;
case 142:
#line 1175 "erlang.y"
{	
        string s;

        if (CurrentTable != NULL)
        {
#ifdef _ALLOCS_H
		    s = CurrentTable->add_temp();
#endif
        }
        yyval.nodelist = new EList(s); 
    }
break;
case 143:
#line 1187 "erlang.y"
{	
		yyvsp[-1].nodelist->prepend(yyvsp[-2].node);
		yyval.nodelist = yyvsp[-1].nodelist;
	}
break;
case 144:
#line 1193 "erlang.y"
{	yyval.nodelist = new GuardTail(yyvsp[0].node); }
break;
case 145:
#line 1195 "erlang.y"
{	
		yyvsp[0].nodelist->prepend(yyvsp[-1].node);
		yyval.nodelist = yyvsp[0].nodelist;
	}
break;
case 146:
#line 1200 "erlang.y"
{	yyval.nodelist = new GuardTail; }
break;
case 147:
#line 1204 "erlang.y"
{	yyval.node = new GuardTuple; }
break;
case 148:
#line 1206 "erlang.y"
{	yyval.node = new GuardTuple(yyvsp[-1].exprlist); }
break;
case 149:
#line 1209 "erlang.y"
{	yyval.exprlist = new ExprList(yyvsp[0].node); }
break;
case 150:
#line 1211 "erlang.y"
{	
		yyvsp[0].exprlist->prepend(yyvsp[-2].node); 
		yyval.exprlist = yyvsp[0].exprlist;
	}
break;
case 151:
#line 1217 "erlang.y"
{	
        string fname;
        int x, size;
        Symbol * other;

        if (yyvsp[-1].exprlist) size = yyvsp[-1].exprlist->size();
        else size = 0;

        fname = Namer::semi_mangle(*(yyvsp[-3].stringp),size);

        yyval.node = new GuardCall(yyvsp[-3].stringp, yyvsp[-1].exprlist); 
		/* Need to do some clever stuff in here with imported modules	*/
        if ( (other = yy_program->Table.find(fname, S_Function)) )
        {
            x = other->used();
            other->used(x+1);
        }
    }
break;
case 152:
#line 1237 "erlang.y"
{	yyval.exprlist = yyvsp[0].exprlist; }
break;
case 153:
#line 1239 "erlang.y"
{	yyval.exprlist = NULL; }
break;
case 154:
#line 1243 "erlang.y"
{	
        string fname = Namer::semi_mangle(*(yyvsp[-3].stringp),yyvsp[-1].exprlist->size());
        Symbol * other;
        BifTest * bt;
        int x, tbt;

        bt = new BifTest(yyvsp[-3].stringp, yyvsp[-1].exprlist); 

        if ((tbt = bt->is_internal()))
        {
            yyvsp[-1].exprlist->type_all(tbt);
        }

		/* Need to do some clever stuff in here with imported modules	*/
        if ( (other = yy_program->Table.find(fname, S_Function)) )
        {
            x = other->used();
            other->used(x+1);
        }
        yyval.node = bt;
    }
break;
case 155:
#line 1266 "erlang.y"
{	yyval.node = yyvsp[0].node; }
break;
case 156:
#line 1268 "erlang.y"
{	
		yyval.node = new GuardTest(*(yyvsp[-1].stringp), yyvsp[-2].node, yyvsp[0].node); 
		delete yyvsp[-1].stringp;
	}
break;
case 157:
#line 1274 "erlang.y"
{	yyval.nodelist = new GuardTestList(yyvsp[0].node); }
break;
case 158:
#line 1276 "erlang.y"
{	
		yyvsp[0].nodelist->prepend(yyvsp[-2].node);
		yyval.nodelist = yyvsp[0].nodelist;
	}
break;
case 159:
#line 1282 "erlang.y"
{	yyval.node = new GuardBool(yyvsp[0].number); }
break;
case 160:
#line 1284 "erlang.y"
{ 	yyval.node = yyvsp[0].nodelist; }
break;
case 161:
#line 1287 "erlang.y"
{
        SymbolTable * s;
        string anonname = Namer::anon_function();
		string ts = "";

 		s = new SymbolTable(anonname, S_Function, ts, 0);
 		retsymbol = new Symbol("_ret", S_Variable, ts);
        s->add(retsymbol);
        s->name(anonname);
        TableStack.push_front(s);
		CurrentTable = s;
    }
break;
case 162:
#line 1300 "erlang.y"
{
        ClauseHead * ch;
        FunctionClause * fc;
        AnonFunctionList * anonfun;
        string anonname;

        /* add param symbols to local scope ..*/
        yyvsp[-4].nodelist->add_symbol(CurrentTable, LT_param);

        anonname = CurrentTable->name();
		ch = new ClauseHead(anonname, anonname, yyvsp[-4].nodelist); 
        fc = new FunctionClause(ch, yyvsp[-2].node, yyvsp[-1].node);
        yyvsp[-1].node->parent(fc);
        fc->type(yyvsp[-1].node->type() | LT_on_heap);
        ((ClauseBody *) yyvsp[-1].node)->scope(CurrentTable);
        ((ClauseBody *) yyvsp[-1].node)->add_final(CurrentTable);

        fc->parent(yy_program->local);

        anonfun = new AnonFunctionList();
        anonfun->parent(yy_program->local);

        anonfun->append(fc);

        yy_program->local->append(anonfun);

        yyval.node = new AnonFunction(fc);
        yyval.node->type(fc->type());

        /* FIX: find "undeclared" variables in anon function*/
        /*      add them as parameter*/
        
        TableStack.pop_front();
    }
break;
case 163:
#line 1336 "erlang.y"
{	
        yyval.node = new FunctionClause(yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node); 
        yyvsp[0].node->parent(yyval.node);
        yyval.node->type(yyvsp[0].node->type() | LT_on_heap);
        ((ClauseBody *) yyvsp[0].node)->scope(CurrentTable);
        ((ClauseBody *) yyvsp[0].node)->add_final(CurrentTable);
        TableStack.pop_front();
     }
break;
case 164:
#line 1347 "erlang.y"
{
		SymbolTable * s;
		string ts = "";
		string chid;

        tmp_val_count = 0;
		chid = *(yyvsp[0].stringp) + itoa(clause_id++);

 		s = new SymbolTable(chid, S_Function, ts, 0);
 		retsymbol = new Symbol("_ret", S_Variable, ts);
        s->add(retsymbol);

        TableStack.push_front(s);
		CurrentTable = s;
    }
break;
case 165:
#line 1363 "erlang.y"
{	
		Symbol * sf;
		string ts = "";
        string func, fname;
		int params = 0;
		string chid = *(yyvsp[-4].stringp) + itoa(clause_id-1);

		if (yyvsp[-1].nodelist != NULL)
		{
			params = yyvsp[-1].nodelist->size();
		}

        CurrentTable->params(params);
        fname = *(yyvsp[-4].stringp);
		func = Namer::semi_mangle(fname, params);
        /* fprintf(stderr, "CT->set_name(%s)\n", func.c_str());*/

        CurrentTable->name(fname);

		/* fprintf(stderr, "yy_program add: %s\n", CurrentTable->full_symbol().c_str());*/
		yy_program->Table.add(CurrentTable);

		if (yy_program->Table.find(func, S_Function) == 0)
		{
			/* fprintf(stderr, "Adding (%s)\n", func.c_str());*/
 			sf = new Symbol(func, S_Function, ts, params);
			yy_program->Table.add(sf);
		}
        else
        {
			/*fprintf(stderr, "FOUND (%s)\n", func.c_str());*/
        }

        /* This adds variables into the local scope*/
        /* and has them set as derived from param*/
        yyvsp[-1].nodelist->add_symbol(CurrentTable, LT_param);

		yyval.node = new ClauseHead(chid,fname,yyvsp[-1].nodelist); 
        yyval.node->line(current_line);
	}
break;
case 166:
#line 1405 "erlang.y"
{	yyval.nodelist = new PatternList(); }
break;
case 167:
#line 1407 "erlang.y"
{	yyval.nodelist = yyvsp[0].nodelist; }
break;
case 168:
#line 1410 "erlang.y"
{	yyval.node = NULL; }
break;
case 169:
#line 1412 "erlang.y"
{	yyval.node = new When(yyvsp[0].node); }
break;
case 170:
#line 1415 "erlang.y"
{	
        yyval.node = new ClauseBody(yyvsp[0].exprlist); 
        yyval.node->type(yyvsp[0].exprlist->type());
    }
break;
case 171:
#line 1420 "erlang.y"
{   
        yyval.node = yyvsp[0].node; 
        yyval.node->type(LT_anyvar);
    }
break;
case 172:
#line 1426 "erlang.y"
{	
        yyval.funclist = active_function;
        yyval.funclist->prepend(yyvsp[0].node);
        yyval.funclist->type(yyvsp[0].node->type());
        yyvsp[0].node->parent(yyval.funclist);
    }
break;
case 173:
#line 1433 "erlang.y"
{	
        /* FIX: check $3 and $1 have the same # of parameters..*/
		yyvsp[0].funclist->prepend(yyvsp[-2].node); 
        yyvsp[-2].node->parent(yyvsp[0].funclist);
        yyvsp[0].funclist->type(yyvsp[-2].node->type() | yyvsp[0].funclist->type());
		yyval.funclist = yyvsp[0].funclist;
	}
break;
case 174:
#line 1442 "erlang.y"
{ 
        yyval.nodelist = new NodeList(new Define(*(yyvsp[0].stringp))); 
    }
break;
case 175:
#line 1446 "erlang.y"
{   
        yyvsp[0].nodelist->prepend(new Define(*(yyvsp[-2].stringp)));
        yyval.nodelist = yyvsp[0].nodelist;
    }
break;
case 176:
#line 1453 "erlang.y"
{
        if (debug)
            fprintf(stderr,"def_clause T_atom\n");
        yyval.defclause = new DefClause(*(yyvsp[0].stringp), NULL);
    }
break;
case 177:
#line 1459 "erlang.y"
{
        if (debug)
            fprintf(stderr,"def_clause T_atom ( def_params )\n");
        yyval.defclause = new DefClause(*(yyvsp[-3].stringp), yyvsp[-1].nodelist);
    }
break;
case 178:
#line 1466 "erlang.y"
{	yyval.attribute = new Attribute(yyvsp[0].node); }
break;
case 179:
#line 1468 "erlang.y"
{	yyval.attribute = new Attribute(NULL, yyvsp[-1].nodelist); }
break;
case 180:
#line 1470 "erlang.y"
{	yyval.attribute = new Attribute(yyvsp[-4].stringp, yyvsp[-1].nodelist); }
break;
case 181:
#line 1472 "erlang.y"
{   yyval.attribute = new Attribute(yyvsp[-4].stringp, yyvsp[-1].exprlist); }
break;
case 182:
#line 1475 "erlang.y"
{	yyval.nodelist = new FarityList(yyvsp[0].node); }
break;
case 183:
#line 1477 "erlang.y"
{	
		yyvsp[0].nodelist->prepend(yyvsp[-2].node);
		yyval.nodelist = yyvsp[0].nodelist;
	}
break;
case 184:
#line 1483 "erlang.y"
{	yyval.node = new Farity(yyvsp[-2].stringp, yyvsp[0].number); }
break;
#line 2772 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
