
/*
 * ExprList (subclass of NodeList)
 *
 * PURPOSE: 
 *    + provide for specifically formatted emission of NodeList code
 *
 */

#ifndef _EXPR_H
#define _EXPR_H

#include "node.h"

//
// We need to add emit_pattern() - to node.h or just locally here?
//

class SymbolTable;

class ExprList : public NodeList
{
    int    val_start;
    int    recur_params;

public:
    ExprList();
    ExprList(Node *);
    list<string> emit_code();
    string print();
    string emit_pattern();
    string emit_local(SymbolTable *, const string& lab);
    string emit_nonlocal(SymbolTable *);
    string emit_nonlocal_list();

    int allocate_locals(int start);

    void returned(SymbolTable *s);
        // Ensures variables which are to be freed aren't returned..

    void add_symbol(SymbolTable * st, int df);
        // Ensures variables which are to be freed aren't returned..

    void recursive_params(int x) { recur_params = x; }
        // are we part of a block with recursion
        // and are there some parameters to be freed?
        
#if 0
    void type(int);
        // set up all expressions in this list with this type..

    int type();
        // hmm... shouldn't be necessary..
#endif
};


#endif
