

//
// $Id: farity.cc,v 1.8 2002/08/05 08:03:19 geoff Exp $
//
// $Source: /home/cvs/gerl/src/farity.cc,v $
// $Revision: 1.8 $
// $Date: 2002/08/05 08:03:19 $
// $State: Exp $
//
// Author: Geoff Wong
//

#include "farity.h"
#include "str.h"

Farity::Farity(const string * str, int n)
{
	_name =  *str;
	_farity = n;
}

list<string> Farity::emit_code()
{
	return string2list(_name + "_" + itoa(_farity));
}

string Farity::print()
{
	return _name + "/" + itoa(_farity);
}

FarityList::FarityList(Node * n)
{
    nodes.push_front(n);
}

string Farity::name() 
{ 
    return _name + "_" + itoa(_farity); 
}

Attribute::Attribute(const string * n, NodeList * l)
{
	vlist = l;
	if (n != NULL) name = *n;
	node = NULL;
}

Attribute::Attribute(const string * n, Node * l)
{
	vlist = NULL;
	if (n != NULL) name = *n;
	node = l;
}

Attribute::Attribute(Node * n)
{
	node = n;
	vlist = NULL;
}


// FIX:
list<string> Attribute::emit_code()
{
	string ret;

	if (vlist != NULL)
	{
		return vlist->emit_code();
	}
	else if (node != NULL)
	{
		return node->emit_code();
	}
	else if (name.length())
	{
		return string2list(name);
	}
	else assert(0);
}

string Attribute::print()
{
	string ret;

	if (vlist != NULL)
	{
		ret = vlist->print();
	}
	else if (node != NULL)
	{
		ret = node->print();
	}
	else if (name.length())
	{
		return name;
	}
	else assert(0);

	return ret;
}
