//
// $Id: farity.h,v 1.8 2002/08/05 08:03:19 geoff Exp $
//
// $Source: /home/cvs/gerl/src/farity.h,v $
// $Revision: 1.8 $
// $Date: 2002/08/05 08:03:19 $
// $State: Exp $
//
// Author: Geoff Wong
//
// Notes:
//    Farities are a import/export name/param pair
//    FarityList is an import/export list (import/export given as a named
//		parameter
//
#ifndef _FARITY_H
#define _FARITY_H

#include "node.h"

//
// An import / export specification
//
class Farity : public Node
{
	string _name;
	int _farity;
public:
	Farity(const string *, int);

	list<string> emit_code();
	string print();

    int params() { return _farity; }
    string name();
};

//
// List of imports/exports
//
class FarityList : public NodeList
{
public:
	FarityList(Node *);
};

//
// Class Attribute
// Handle various initial attributes:
//		import, export, module, compile
//
// Notes: Program directly accesses the internals
//		Funny kind of container with overloaded functionality
//		because of the bad grammar. Maybe erlang.y should be fixed..
//
class Attribute : public Node
{
	friend class Program;
	string 		name;
	NodeList 	* vlist;
	Node 		* node;
public:
	Attribute(const string *, NodeList *);
	Attribute(const string *, Node *);
	Attribute(Node *);
	list<string> emit_code();
	string print();
    string module() { return name; }
};


#endif
