

//
// $Id: form.cc,v 1.9 2001/06/18 15:32:13 geoff Exp $
//
// $Source: /home/cvs/gerl/src/form.cc,v $
// $Revision: 1.9 $
// $Date: 2001/06/18 15:32:13 $
// $State: Exp $
//
// Author: Geoff Wong
//

#include <assert.h>
#include "form.h"

Form::Form(string * str, Node * attrib)
{
	name = *str;
	value = attrib;	
}

string Form::print()
{
	return "-" + name + "(" + value->print() + ")";
}

FormList::FormList()
{
	NodeList();
}

list<string> Form::emit_code()
{
	return string2list("/* "+name+":" + value->expr_code() + "*/");
}

FormList::FormList(Node * n)
{
	nodes.push_front(n);
}

string FormList::print()
{
    string ret;
    list<Node *>::iterator i;

    for (i = nodes.begin(); i != nodes.end(); i++)
    {
        if ((*i) != NULL)
            ret = ret + (*i)->print() + ".\n";
    }
    return ret;
}

void FormList::set_program(Program * p)
{
//	printf("Setting program %d\n", p);
	program = p;
}

list<string> FormList::emit_code()
{
	list<Node *>::iterator i;
	string ret;

	assert(program != NULL);

	for (i = nodes.begin(); i != nodes.end(); i++)
	{
#if 0
		if (((Form *)(*i))->name == "module")
		{
//			printf("module value:%s\n", ((Form *)(*i))->value->emit_code().c_str());
			program->set_module(((Form *)(*i))->value);	
		}
#endif
		// ret = ret + (*i)->emit_code() + "\n";
        if ((*i) != NULL)
		    printf("%s\n", ((*i)->expr_code()).c_str());
	}
	return string2list(ret);
}
