
//
//	Erlang Compiler with Monitoring Support
//
//	Geoff Wong (C) Copyright 1996,1997,1998.
//	C/O RMIT University
//	Swanston St. Melbourne 3001.
//	Australia
//
//	email: geoff@serc.rmit.edu.au
//
//	This file is distributed under the terms of the 
//	GNU Public License, details of which can be found
//	in the file "Copying" which accompanies this code.
//

#ifndef _FORM_H
#define _FORM_H

#include "node.h"
#include "program.h"

class Form : public Node
{
public:
	string 	name;
	Node 	* value;

	Form(string * atom, Node * attrib);
	list<string> emit_code();
	string print();	

};

class FormList : public NodeList
{
	Program * program;
public:
	FormList();
	FormList(Node *);

	string print();
	list<string> emit_code();

	void set_program(Program * p);	
		// allow the program to tell us who we are
};

#endif
