

//
// $Id: function.cc,v 1.78 2004/09/05 02:42:56 geoff Exp $
//
// $Source: /home/cvs/gerl/src/function.cc,v $
// $Revision: 1.78 $
// $Date: 2004/09/05 02:42:56 $
// $State: Exp $
//
// Author: Geoff Wong
//

#include "str.h"
#include "function.h"
#include "program.h"
#include "error.h"

// #define DEBUG

extern int debug;

void dum() { } 

#if 0
//HACK
int operator==(const Dictionary<Symbol *>::iterator& it1,
                               const Dictionary<Symbol *>::iterator& it2)
{
       if ((it1.where == it2.where)
                && (it1.ihash == it2.ihash)) return 1;
       return 0;
}
#endif

FunctionList::FunctionList()
{
    _lco = false;
}

FunctionList::FunctionList(Node * n)
{
    _lco = false;
	nodes.push_front(n);
}

string FunctionList::doparams(int num)
{
	int x;
	string ret = "(";

	if (num == 0)
	{
		ret = ret + "void";
	}
	else
	{
		for (x = 0; x < num; x++)
		{
			if (x != 0) ret = ret + ",";
			ret = ret + "Val p" + itoa(x); 
		}
	}

	ret = ret + ")";

	return ret;
}


#if 0
string FunctionList::fullname()
{
	string name;
	string ret;
	int param;

	param = ((FunctionClause *)(*i))->num_params();
	name = ((FunctionClause *)(*i))->clausename();

    ret  = mangle(name,param);

    return ret;
}
#endif

list<string> FunctionList::emit_code()
{
	list<Node *>::iterator i;
    list<string> lret, code;
    string fullname;
	string name;
	string instr;
	string out;
	string out1;
	int param;
    int loop;

	i = nodes.begin();
    if ((*i) == NULL) return lret;

	param = ((FunctionClause *)(*i))->num_params();
	name = ((FunctionClause *)(*i))->clausename();

	if (verify(name, param) == 0)
	{
		fprintf(stderr, "Inconsistent naming or number of parameters in a function clause.\n");
		return lret;
	}

	// get the C function built
    fullname = mangle(name,param);
	lret.push_back("Val " + fullname + doparams(param) + "\n{\n");
    
    // error support ..
    error.function((yy_program->Module() + ":" + name + "/" + itoa(param)));

    // put in a temp value for stack allocation (__vvv)
    lret.push_back("\tVal __vvv,_ret;\n");

    // put in a set_stack if we need it ...
    if (_lco == true)
    {
        if (param > 0) 
        {
            instr = "\tVal ";
            for (loop = 0; loop < param; loop++)
            {
                instr = instr + "op" + itoa(loop); // + "=" + "p" + itoa(loop); 
                if (loop != (param - 1)) instr = instr + ", ";
            }
            if (instr.empty() == false) instr = instr + ";\n";
            lret.push_back(instr);
        }
        lret.push_back("\tint recur = 0;\n\twhile (1) {\n");

        instr = "";
        for (loop = 0; loop < param; loop++)
        {
            instr = instr + "\top" + itoa(loop) + "=" + "p" + itoa(loop) + ";\n";
        }
        lret.push_back(instr);
    }

    // put in a label for tail-recursion
    // ret = ret + "L" + fullname + ":\n";

    // put in debugging print statements
    if (debug)
    {
        lret.push_back("\tfprintf(stderr, \"" + fullname 
            + "\\n\"" + out1 + ");\n");
#if 0
        for (loop = 0; loop < param; loop++)
        {
            ret = ret + "EPrintvalue(stderr,p" + itoa(loop) + "); fputc('\\n', stderr);\n";
        }
#endif
    }

	// do the clauses as "if" statements
	for (i = nodes.begin(); i != nodes.end(); i++)
	{
        if ((*i) != NULL)
        {
            FunctionClause * fc;
            fc = (FunctionClause *)(*i);
            fc->lco(_lco);    
            code = fc->emit_code();    
            lret.insert(lret.end(), code.begin(), code.end());
        }
	}

	// finish it off
    instr = "\tEthrowv(\"Failed to match function clause "+name+"/"+
            itoa(param)+".\\n";

    for (loop = 0; loop < param; loop++)
    {
        out = out + "\\t%s\\n";
        out1 = out1 + ",ESV(p"+itoa(loop)+")";
    }
    
    instr = instr + out + "\"" + out1 + ");\n";
    if (_lco == true) instr = instr + "\t}\n";
    lret.push_back(instr);

	lret.push_back("}\n");

	return lret;
}

string FunctionList::print()
{
    string ret;
    list<Node *>::iterator i;

    for (i = nodes.begin(); i != nodes.end(); i++)
    {
		if (i != nodes.begin())
			ret = ret + ";\n";
        ret = ret + (*i)->print();
    }
    return ret;
}

string FunctionList::mangle(string& name, int param)
{
    string mod = program->Module();
	return Namer::mangle(mod,name,param);
}

#if 0
string FunctionList::demangle(string& cname)
{ }
#endif

int FunctionList::verify(const string& name, int param)
{
	list<Node *>::iterator i;
	
	for (i = nodes.begin(); i != nodes.end(); i++)
	{
#if 0
		if ((((FunctionClause *)(*i))->num_params() != param) ||
			(((FunctionClause *)(*i))->name() != name)) 
		{
			// we got problems!
			return 0;
		}
#endif
	}
	return 1;
}

bool FunctionList::lco()
{
    return _lco;
}

void FunctionList::lco(bool t)
{
    _lco = t;
}




FunctionClause::FunctionClause(Node * h, Node * g, Node * b)
{
	head = (ClauseHead *) h;
	guard = (When *) g;
	body = (ClauseBody *) b;
}

list<string> FunctionClause::emit_code()
{
	SymbolTable * st = 0;
    list<string> lret, code, precode;
    list<string>::iterator i, pos;
    string fr;

    st = body->scope();
    if (_lco) body->lco(num_params());

#ifdef DEBUG
//	st = (SymbolTable *)yy_program->Table.find(head->name, S_Function);
//	if (st = (SymbolTable *)yy_program->Table.find(head->name, S_Function))
//		printf("ST exists\n");
fprintf(stderr, "FC: name=|%s|\n", head->name.c_str());
#endif

	if (st == NULL) dum();
	assert(st != NULL);	

    TableStack.push_front(st);
    CurrentTable = TableStack.front();

#ifdef DEBUG
//	fprintf(stderr, "Clausename: %s (%s:%d)\n", head->name.c_str(), 
//   st->_symbol.c_str(), st->Table.num_elements());
#endif
	assert(st != 0);

	// three parts - head(params), guard, body
	// need to emit an if stmt for the pattern match
	// then also need to ensure the guard also matches

    if (debug == 0)
    {
        lret.push_back("#line " + itoa(head->line()) + " \"" + 
            yy_program->Module() + ".erl\"\n");
    }
    else
    {
        debug = 1;
    }
	
	// do each of the parameters for the pattern match
	// Note: needs to assign each parameter to its variable slot
	// in the appropriate symbol table.
	lret.push_back("\tif (" + head->param_match() + ")\n\t{\n");


    // Emit the local Val declarations
    // CHANGED: 20020724 - need to extract parameter names to outer block
    lret.push_back(body->emit_locals());
    if (debug == 0)
    {
        lret.push_back("#line " + itoa(head->line()+1) + " \"" + 
            yy_program->Module() + ".erl\"\n\t");
    }
    body->set_emitted(true);

	// Also emit any type checking assertions
	lret.push_back(head->expr_code());
	
	// guard
	if (guard != NULL)
	{
        fr = body->emit_frees(LT_param);
		lret.push_back("\tif (" + guard->expr_code() + ")\n\t{\n");
	}

	// body
	code = body->emit_code();
    precode = body->pre_code();
    //printf("function pre_code =##%s##=\n", join(precode, "\n").c_str());

    lret.insert(lret.end(), precode.begin(), precode.end());
    lret.insert(lret.end(), code.begin(), code.end());

	lret.push_back("\t}\n");

	// close guard braces
	if (guard != NULL)
	{
        lret.push_back(fr + "\n");
	    lret.push_back("\t}\n");
	}


    TableStack.pop_front();
    CurrentTable = TableStack.front();
	
	return lret;
}

string FunctionClause::print()
{
	string ret;
	ret = head->print() + guard->print() + "->\n";
	tablevel++;
	ret = ret + tabs() + body->print();
	tablevel--;
	return ret;
}

string FunctionClause::name()
{
	return head->name;
}

string FunctionClause::clausename()
{
	return head->clausename;
}

int FunctionClause::num_params()
{
	return head->num_params();
}

#if 0
bool FunctionClause::lco()
{
    return _lco;
}

void FunctionClause::lco(bool t)
{
    _lco = t;
}
#endif


void FunctionList::set_program(Program * p)
{
	program = p;
}

FunctionCall::FunctionCall(const string * mod, const string * nm, 
                            ExprList * n, Symbol * f)
{
    dmodule = NULL;
	module = *mod;
	name = *nm;
	value = n;
    _LCO = LCO_non;
    _freesym = f;
    if (_freesym != NULL)
        _freesym->type(LT_normal | LT_on_heap);                                     
}

FunctionCall::FunctionCall(Node * mod, const string * nm, 
                            ExprList * n, Symbol * f)
{
    dmodule = mod;
	name = *nm;
	value = n;
    _LCO = LCO_non;
    _freesym = f;
    if (_freesym != NULL)
        _freesym->type(LT_normal | LT_on_heap);                                     
}

//
// Should emit
//  (T1 = param1, T2 = param2, function_call(T1, T2))
//  cause of weird problems 
list<string> FunctionCall::emit_code()
{
	assert(value != NULL);

	string ret;
	int param = value->nodes.size();

#if 0
    fprintf(stderr, "Fcall = %s_%d, LCO = %d, depth  %d, CT = %s\n",
        name.c_str(), param, _LCO, depth, CurrentTable->symbol().c_str());
#endif

	// FIX: check for LCO here.
    if (_LCO == LCO_localfun && depth == 2)
    {
	    //string tmp = "L" + Namer::mangle(module,name,param);
	    string tmp = "recur = 1; continue;";
        // if (_parent) _parent->extra(tmp);
        ret = value->emit_local(_scope, tmp);
        return string2list(ret);
    }
    else if (_LCO == LCO_local || _LCO == LCO_localfun)
    {
#if 0
        // Bifs and stuff in Erlang
        fprintf(stderr, "LCO = LCO_local\n");
#endif
        ret = Namer::mangle(module,name,param);
        if (param > 0) 
        {
            ret = "(" + value->emit_nonlocal(_scope) + ret;
            ret = ret + "(" + value->emit_nonlocal_list() + "))";
        }
        else 
        {
            ret = ret + "()";
        }
    }
    else /* if (_LCO == LCO_external) */
    {
#if 0
        if (_LCO == LCO_non)
            fprintf(stderr, "LOC = LOC_non\n");
        else
            fprintf(stderr, "LOC = LOC_extenerl\n");
#endif
        // NOTE: nothing to with LCO
        // actually just an external module call
        ret = "Esym(\"" + module + ".so\",\"" + 
            Namer::mangle(module,name,param) + "\")";
        if (param > 0) 
        {
            ret = "(" + value->emit_nonlocal(_scope) + ret;
            ret = ret + "(" + value->emit_nonlocal_list() + "))";
        }
        else 
        {
            ret = ret + "()";
        }
    }

    if (Node::freesym() != NULL)
    {
        ret = "(" + Node::freesym()->symbol() + "=" + ret + ")";
    }

	return string2list(ret);
}

void FunctionCall::freesym(Symbol * s)
{
    // existing freesym should be cleared.
    if (s == NULL && _freesym != NULL)
    {
        _freesym->type(_type & ~LT_on_heap);
    }

    _freesym = s; 
    if (s != NULL)
    {
        _freesym->type(_type | LT_on_heap);
    }
}

string FunctionCall::print()
{
	return name + "(" + value->print() + ")";
}

void FunctionCall::LCO(Lastcall v)
{
    _LCO = v;
}

bool FunctionCall::typecheck(Etype check, Etype restrict)
{
    Symbol * s;

#if 0
    if (debug)
        fprintf(stderr,"FunctionCall::type(enter) == %d\n", type());
    if (module == yy_program->Module())
    {
        s = yy_program->Table.find(name, S_Function);
        if (s == NULL)
        {
            fprintf(stderr,"Unknown function call (%s).\n", name.c_str());
            exit(1);
        }
        type(s->type());
    }
    if (debug)
        fprintf(stderr,"FunctionCall::type(set) == %d\n", type());
#endif

    return Node::typecheck(check, restrict);

#if 0
    Node * tfl;
    FunctionList * fl;
    // a hack - probably shouldn't be here...
    // done in this like a pre-parse to the code emission
    // exprs -> clause_body -> function_clause -> function list
    tfl = parent();
    while (tfl->parent() != NULL)
    {
        tfl = tfl->parent();
    }
    if (tfl == NULL) return;
    fl = (FunctionList *) tfl;
    // FIX: do something?
    return true;
#endif
}

void FunctionCall::scope(SymbolTable * s)
{
    _scope = s;
}

RemoteCall::RemoteCall(const string *, const string *, Node *)
{
}

list<string> RemoteCall::emit_code()
{
    list<string> empty;
	return empty;
}

string RemoteCall::print()
{
	return "";
}

ClauseHead::ClauseHead(string& str, string& cn, NodeList * exp)
{
	// Initialise with an Atom (name) and list of expressions
	name = str;
	clausename = cn;	
	expr = exp;
}

string ClauseHead::param_match()
{
	return expr->emit_pattern("");
}

list<string> ClauseHead::emit_code()
{
	string wh("ClauseHead: ");
//	fprintf(stderr, "%s\n", (wh + name).c_str());
    Program::val_count = 0;
    //add_pre_code(expr->pre_code());
	return expr->emit_code();
}

string ClauseHead::print()
{
	// printf("ClauseHead: print()\n");
	if (expr == 0) 
	{
		return name + "()";
	}
	return name + "(" + expr->print() + ")";
}

int ClauseHead::num_params()
{
	return expr->size();
}

ClauseBody::ClauseBody(ExprList * n)
{
	value = n;
    _scope = NULL;
    _emitted = false;
    _lco_params = 0;
}

list<string> ClauseBody::emit_code()
{
    string ex, fr;
    list<string> lret, vcode;

	assert(value != 0);

    if (_emitted == false) lret.push_back(emit_locals());

    if (_lco_params)
    {
        // Do some LCO stuff
        value->recursive_params(_lco_params);
    }
    vcode = value->emit_code();
    add_pre_code(value->pre_code());
	lret.insert(lret.end(), vcode.begin(), vcode.end());
    fr = emit_frees(LT_all);
    ex = value->extra();
    lret.push_back(fr + "\t" + ex + "\n");
    return lret;
}

string ClauseBody::print()
{
	// printf("ClauseBody: print()\n");
	return value->print();
}

void ClauseBody::set_emitted(bool val)
{
    _emitted = val;
}

void ClauseBody::set_depth(int x)
{
    depth = x;
    value->set_depth(x);
}

void ClauseBody::delimiter(const string& str)
{
    value->delimiter(str);
}

void ClauseBody::scope(SymbolTable * s)
{
    _scope = s;
}

void ClauseBody::assign(Symbol * x)
{
    //Node::assign(x);
    value->assign(x);
}

void ClauseBody::add_final(SymbolTable * st)
{
    list<Node *>::iterator i;

    if (debug)
        fprintf(stderr, "ClauseBody::add_final()\n");
    value->add_symbol(st, LT_none);

#if 0
    i = --(value->nodes.end());
    (*i)->add_symbol(st,LT_returned);
#endif

}

SymbolTable * ClauseBody::scope()
{
    return _scope;
}

When::When(Node * n)
{
	value = n;
}

#define MAX_VAL_PER_LINE 8

string ClauseBody::emit_locals()
{
    string postret, ret, prm;
	Dictionary <Symbol *>::iterator j;
    string outtype;
    int count = 0;

	// label parameters with their local names assigned by pattern match
	// Use symboltable built in 1st parse

    assert(_scope != NULL);

	for (j = _scope->Table.begin(); j != _scope->Table.end(); j++)
	{
        Symbol * sym;

        sym = (*j);
        if (sym == NULL) continue;

        if (count == 0)
        {
            outtype = "\tVal ";
        }
        else
        {
            outtype = ",";
        }
#if 0
		fprintf(stderr,"FCST: %s (%s:%s)\n", (*_scope).symbol().c_str(),
				(*j)->symbol().c_str(), (*j)->parameter().c_str());

        if (sym->symboltype == S_Boolean) outtype = "\tint ";
#endif

		if (sym->parameter().length() == 0)
		{
			ret = ret + outtype + sym->symbol();
            count++;
		}	
		else
		{
            prm = sym->parameter();

            if (sym->destructive())
            {
                ret = ret + outtype + sym->symbol();
                // what about assigning op?
			    postret = postret + "\t" + sym->symbol() + " = " + sym->parameter() + ";\n";
            }
            else
            {
			    ret = ret + outtype + sym->symbol() + " = " + sym->parameter();
            }
            count++;
		}

        if (count == MAX_VAL_PER_LINE)
        {
                ret = ret + ";\n";
                count = 0;
        }
	}

    if (count)
    {
        ret = ret + ";\n";
    }

    // put destructive assignments last ..
    ret = ret + postret;

    return ret;
}

//
// Frees are emitted if a variable in the scope table
// is marked as 'LT_on_heap'
//
string ClauseBody::emit_frees(int type)
{
    string ret;
	Dictionary <Symbol *>::iterator j;
    Symbol * sym;
    int count = 0;

	for (j = _scope->Table.begin(); j != _scope->Table.end(); j++)
	{
        sym = (*j);
        if (sym == NULL) continue;
        if ((sym->type() & type) && (sym->type() & LT_on_heap)) 
        {
            //if (sym->destructive())
    		//    ret = ret + "Efred(" + sym->symbol() + ");";
            //else
            
    		ret = ret + "Efre(" + sym->symbol() + ");";
            if (++count % 6 == 0) ret = ret + "\n\t";
        }
    }

    if (ret.empty() == false)
    {
        ret = "\t" + ret;
        if (count % 6 != 0) ret = ret + "\n";
    }

    return ret;
}

list<string> When::emit_code()
{
	return value->emit_code();
}

string When::print()
{
	return " when " + value->print();
}


AnonFunction::AnonFunction(FunctionClause * f)
{
    func = f;
}

list<string> AnonFunction::emit_code()
{
    return string2list("EValfunc("+func->name()+")");
}

string AnonFunction::print()
{
    return "AnonFunction";
}

int AnonFunction::num_params()
{
    return func->num_params();
}

string AnonFunction::name()
{
    return func->name();
}

string AnonFunction::clausename()
{
    return func->clausename();
}

list<string> AnonFunctionList::emit_code()
{
	list<Node *>::iterator i;
    list<string> lret, code;
	string name;
	string instr;
	string out;
	string out1;
	int param;
    int loop;

	i = nodes.begin();
    if ((*i) == NULL) return lret;

	param = ((FunctionClause *)(*i))->num_params();
	name = ((FunctionClause *)(*i))->clausename();

	// get the C function built
	lret.push_back("Val " + name + doparams(param) + "\n{\n");
    
    // error support ..
    error.function((yy_program->Module() + ":" + name + "/" + itoa(param)));

    // put in a temp value for stack allocation (__vvv)
    lret.push_back("\tVal __vvv,_ret,_oldp;\n");

    // put in a set_stack if we need it ...
    if (_lco == true)
    {
        if (param > 0) 
        {
            instr = "\tVal ";
            for (loop = 0; loop < param; loop++)
            {
                instr = instr + "op" + itoa(loop);
                if (loop != (param - 1)) instr = instr + ", ";
            }
            instr = instr + ";\n";
            lret.push_back(instr);
        }
        lret.push_back("\tint recur = 0;\n\twhile (1) {\n");
    }

    // put in a label for tail-recursion
    // ret = ret + "L" + fullname + ":\n";

    // put in debugging print statements
    if (debug)
    {
        lret.push_back("\tfprintf(stderr, \"" + name 
            + "\\n\"" + out1 + ");\n");
#if 0
        for (loop = 0; loop < param; loop++)
        {
            ret = ret + "EPrintvalue(stderr,p" + itoa(loop) + "); fputc('\\n', stderr);\n";
        }
#endif
    }

	// do the clauses as "if" statements
	for (i = nodes.begin(); i != nodes.end(); i++)
	{
        if ((*i) != NULL)
        {
            FunctionClause * fc;

            fc = (FunctionClause *)(*i);
            fc->lco(_lco);    
            code = fc->emit_code();    
            lret.insert(lret.end(), code.begin(), code.end());
        }
	}

	// finish it off
    instr = "\tEthrowv(\"Failed to match function clause "+name+"/"+
            itoa(param)+".\\n";

    for (loop = 0; loop < param; loop++)
    {
        out = out + "\\t%s\\n";
        out1 = out1 + ",ESV(p"+itoa(loop)+")";
    }
    
    instr = instr + out + "\"" + out1 + ");\n";
    if (_lco == true) instr = instr + "\t}\n";
    lret.push_back(instr);

	lret.push_back("}\n");

	return lret;
}

