

//
// $Id: guard.cc,v 1.13 2001/06/18 15:32:15 geoff Exp $
//
// $Source: /home/cvs/gerl/src/guard.cc,v $
// $Revision: 1.13 $
// $Date: 2001/06/18 15:32:15 $
// $State: Exp $
//
// Author: Geoff Wong
//

#include "guard.h"
#include "str.h"

GuardTail::GuardTail()
{
}

GuardTail::GuardTail(Node *)
{
}

#if 0
GuardExprList::GuardExprList(Node *)
{
}
#endif

GuardTuple::GuardTuple()
{
}

GuardTuple::GuardTuple(NodeList * n)
{
	vlist = n;
}

list<string> GuardTuple::emit_code()
{
    list<string> empty;
	return empty;
}

string GuardTuple::print()
{
	return "{ " + vlist->print() + " }";	
}

list<string> GuardExpr::emit_code()
{
	return string2list("GuardExpr");
}

string GuardExpr::print()
{
	return "";
}

GuardCall::GuardCall(const string * s, ExprList * n)
{
	name = *s;
	value = n;
}

list<string> GuardCall::emit_code()
{
    string ret;
	int param;
    string mod = "bif";

	// check for LCO here?.

    if (value != NULL)
    {
	    param = value->nodes.size();
	    ret = Namer::mangle(mod,name,param) + 
                "(" + value->emit_pattern() + ")";
    }
    else
    {
        
	    ret = Namer::mangle(mod,name,0)+"()";
    }
	return string2list(ret);
}

string GuardCall::print()
{
	return name + "(" + value->print() + ")";
}

GuardTest::GuardTest(const string& op, Node * l, Node * r) :
    Binary(op, l, r)           
{
}

list<string> GuardTest::emit_code()
{
    string alhs, arhs, lhs, rhs, res, ret;
    int flag = 0, et, xt;

    et = tag_code(LHS, lhs, alhs);
    if (et) flag++;
    xt = tag_code(RHS, rhs, arhs);
    if (xt) flag++;
    switch(flag)
    {
        case 1:
        case 2:
            return string2list(operate + type_code(LHS) + type_code(RHS)
             + "(" + alhs + ", " + arhs + ")");
        default:
            return string2list(operate + "(" + lhs + ", " + rhs + ")");
    }
}

string GuardTest::print()
{
//	printf("GuardTest::print()\n");
	return comp_op + "(" + left->print() + "," + right->print() + ")";
}

GuardTestList::GuardTestList(NodeList *)
{
}

GuardTestList::GuardTestList(Node * n)
{
	nodes.push_front(n);
}

list<string> GuardTestList::emit_code()
{
	string ret;
    list<Node *>::iterator i;

    for (i = nodes.begin(); i != nodes.end(); i++)
    {
        add_pre_code((*i)->pre_code());
        ret = ret + (*i)->expr_code();
        if (i != --(nodes.end())) ret = ret + " && ";
    }

    return string2list(ret);
}

// Boolean Class
GuardBool::GuardBool(int val)
{
	if (val == 0) value = false;
	else value = true;
}

list<string> GuardBool::emit_code()
{
	if (value == false) 
		return string2list("(0)");
	return string2list("(1)");
}

string GuardBool::print()
{
	if (value == false) 
		return string("false");
	return string("true");
}

BifTest::BifTest(const string * s, ExprList * l)
{
	value = l;
	name = *s;
}

list<string> BifTest::emit_code()
{
	assert(value != NULL);

    string ret;
    string mod = "bif";
	int param;
    int x;

	param = value->nodes.size();

    if (x = is_internal())
    {
        mod = "E";
        value->type_all(x);
	    ret = Namer::mangle(mod,name,param) + "(" + 
                    value->emit_pattern() + ")";
        value->type_all(x);
    }
    else
    {
	    ret = "Etrue(" + Namer::mangle(mod,name,param) + "(" + 
                    value->emit_pattern() + "))";
    }
	return string2list(ret);
}

string BifTest::print()
{
	return name + "(" + value->print() + ")";
}

int BifTest::is_internal()
{
    if (name == "number") return LT_number;
    if (name == "integer") return LT_number;
    if (name == "float") return LT_real;
    if (name == "atom") return LT_atom;
    if (name == "list") return LT_list;
    if (name == "tuple") return LT_tuple;
    if (name == "binary") return LT_binary;
    return LT_none; 
}
