

//
// $Id: guard.h,v 1.11 2001/06/18 15:32:15 geoff Exp $
//
// $Source: /home/cvs/gerl/src/guard.h,v $
// $Revision: 1.11 $
// $Date: 2001/06/18 15:32:15 $
// $State: Exp $
//
// Copyright (C) Geoff Wong (1996, 1997, 1998)
// geoff@cs.rmit.edu.au
//
// This file is distributed under the terms of the
// GNU Public License, details of which can be found
// in the file "Copying" which accompanies this code.        
//

#ifndef _GUARD_H
#define _GUARD_H

#include "binary.h"
#include "expr.h"
#include "namer.h"

class GuardTail : public NodeList
{
public:
	GuardTail();
	GuardTail(Node *);
};

#if 0
class GuardExprList : public ExprList
{
public:
//	GuardExprList(Node * n) : ExprList(n);
};
#endif

class GuardTuple : public Node
{
	NodeList * vlist;
public:
	GuardTuple();
	GuardTuple(NodeList *);

	list<string> emit_code();
	string print();
};

class GuardExpr : public Node
{
public:
	list<string> emit_code();
	string print();
};

class GuardCall : public Node
{
	string name;
	ExprList * value;
public:
	GuardCall(const string *, ExprList *);
	list<string> emit_code();
	string print();
};

class GuardTest : public Binary
{
	Node * left, * right;
	string comp_op;
public:
	GuardTest(const string&, Node *, Node *);
	list<string> emit_code();
	string print();
};


class GuardBool : public Node
{
    bool value;
public:
    GuardBool();
    GuardBool(int);
    string print();
    list<string> emit_code();

};

class GuardTestList : public NodeList
{
public:
	GuardTestList(NodeList *);
	GuardTestList(Node *);

	list<string> emit_code();
};

#if 0
class GuardTests : public NodeList
{
public:
	GuardTests(NodeList *);
};
#endif

class BifTest : public Node
{
	string name;
	ExprList * value;
public:
	BifTest(const string *, ExprList *);

	list<string> emit_code();
	string print();

	int is_internal();
        // Returns the type of the expected number if we support
        // it internally in the library
};

#endif
