

//
// $Id: if.cc,v 1.18 2002/08/03 14:31:42 geoff Exp $
//
// $Source: /home/cvs/gerl/src/if.cc,v $
// $Revision: 1.18 $
// $Date: 2002/08/03 14:31:42 $
// $State: Exp $
//
// Author: Geoff Wong
//


#include "if.h"
#include "str.h"
#include "error.h"

void foobar() { }

If::If(NodeList * l)
{
	vlist = l;	
}

void If::assign(Symbol * x) 
{
    list<Node *>::iterator i;

    Node::assign(x);
#if 0
    vlist->assign(x);
#else
    for (i = vlist->nodes.begin(); i != vlist->nodes.end(); i++)
    {
        (*i)->assign(x);
    }
#endif
}

list<string> If::emit_code() 
{
    list<string> ret;
    string tmp;

    vlist->delimiter("else ");
	ret = vlist->emit_code();
    add_pre_code(vlist->pre_code());
    tmp = tmp + "else\n\t{\n\t\t" + 
            error.emit_exit("if_clause") +";\n\t}\n\t";
    ret.push_back(tmp);
    return ret;
}

list<string> If::pre_code()
{
    vlist->delimiter("\telse ");
    list<string> ret = vlist->emit_code();
    string out = join(ret, "\nelse ");
	//printf("If::pre_code(): %s\n", out.c_str());
    //ret = string2list("fuck");
    return ret;
}

string If::print() 
{
	return "if\n" + vlist->print() + "end";
}

void If::set_depth(int lvl)
{
    depth = lvl;
    vlist->set_depth(lvl);
}

IfClause::IfClause(Node * g, Node * b)
{
    string del = ";\n";
	guard = g;
	body = (ClauseBody *) b;
    body->delimiter(del);
}

list<string> IfClause::pre_code()
{
    //foobar(); //body->pre_code()?
    //return guard->pre_code();
    list<string> pc = Node::pre_code();
    string out = join(pc, "\n");
	//printf("IfClause::pre_code(): %s\n", out.c_str());
    return Node::pre_code();
}

list<string> IfClause::emit_code()
{
    string tmp;
    list<string> ret, ret2, ret3;
    foobar();
	//printf("IfClause::emit_code()\n");
    
    //add_pre_code(
	//    string2list("\tif (" +  guard->expr_code() + ")\n\t{" 
    //        + body->expr_code() + "\t}"));

    ret2 = guard->emit_code();
    ret2.push_front("\tif (");
    ret = body->emit_code();
    ret.push_front(")\n\t{\n");
    ret.insert(ret.begin(), ret2.begin(), ret2.end());
    ret.push_back("\t}\n");
    add_pre_code(ret);
    return ret;
}

string IfClause::print()
{
	// printf("IfClause::print()\n");
	return tabs() + guard->print() + " -> "+  body->print() + "\n";
}

void IfClause::set_depth(int lvl)
{
    depth = lvl;
//   guard->set_depth(lvl);
//   body->set_depth(lvl);
}

void IfClause::assign(Symbol * x)
{
    Node::assign(x);
    //printf("// IfClause::assign: %s\n", x->symbol().c_str());
    body->assign(x);
}

