

//
// $Id: mangle.cc,v 1.15 2002/02/11 11:58:03 geoff Exp $
//
// $Source: /home/cvs/gerl/src/mangle.cc,v $
// $Revision: 1.15 $
// $Date: 2002/02/11 11:58:03 $
// $State: Exp $
//
// Author: Geoff Wong
//

#include "mangle.h"
#include "str.h"
#include "erlib.h"

// #define DEBUG

const int MAX_PARAMS=256;

Mangle::Mangle()
{
}

string Mangle::mangle(string& module, string& name, int param)
{
    _module = module;
    _name = name;
    _noparams = param;
    return mangle();
}

string Mangle::mangle()
{
    return Namer::mangle(_module, _name, _noparams);
}

void Mangle::demangle(string& str)
{
	int x, y, z;
	string pstring;
	
	// module
	x = str.find(':');
	if (x > 0) _module = str.substr(0,x);

	// name 
	y = str.find('(', x);
	if (y != -1)
	{
		_name = str.substr(x+1, y-x-1);
	}

    // FIX: not very robust
    if (str[y+1] == ')')
    {
        _noparams = 0;
        return;
    }

	z = str.rfind(')');
    if (z == -1) z = str.length();

	// do each parameter..	
	string sep = ",";
	string sparams[MAX_PARAMS];

	pstring = str.substr(y+1, z-y-1);
    printf("param string=%s\n", pstring.c_str());

	_noparams = split(pstring, sparams, MAX_PARAMS, sep); 

	// need to parse the parameters (dammit)
	// actually we should parse (and compile) the entire input
	// and use that as "main"
	// For now assume either int, float or string (or list?)

	for (int i = 0; i < _noparams; i++)
	{
#if 1
    fprintf(stderr, "Param(%i) = %s\n", i, sparams[i].c_str());
#endif
		if (sparams[i][0] >= '0' && sparams[i][0] <= '9')
		{
			// it's a number	
			_parameters.push_back(EValint(atoi(sparams[i].c_str())));
		}
		else if (sparams[i][0] == '"')
        {
            int cut = 0;
            if (sparams[i][sparams[i].length()-1] == ')') cut = 1;
            string tmpstr = sparams[i].substr(1, sparams[i].length() - (cut + 2));
            // printf("Pushing %s\n", tmpstr.c_str());
			_parameters.push_back(EValmstring(tmpstr.c_str()));
        }
        else
		{
			fprintf(stderr,"WARNING: unimplemented demangle\n");
#if 0
			// treat it as a string
			_parameters.push_back(itoa(sparams[i].c_str()));
#endif
		}
	}
}

// demangle a static function stmt mod:fun/X
void Mangle::unmangle(string& name)
{
    int m, p;

    m = name.find(':');
    if (m != -1)
    {
        _module = name.substr(0,m);
    }
    else
    {
        m = 0;
    }
    p = name.find('/');
    if (p != -1)
    {
        _noparams = atoi(name.substr(p+1).c_str());
    }
    else
    {
        p = name.length();
    }
    _name = name.substr(m,p);
}


string Mangle::module()
{
	return _module;
}

string Mangle::name()
{
	return _name;
}

int Mangle::params()
{
	return _noparams;
}
