
//
//    Erlang Compiler with Monitoring Support
//
//    Geoff Wong (C) Copyright 1996,1997,1998.
//    C/O RMIT University
//    Swanston St. Melbourne 3001.
//    Australia
//
//    email: geoff@serc.rmit.edu.au
//
//    This file is distributed under the terms of the 
//    GNU Public License, details of which can be found
//    in the file "Copying" which accompanies this code.
//


// @@DOC
// The Mangle class support the transformation of module names
// into unique names for emission into C code.
// @@ENDDOC

#ifndef _MANGLE_H
#define _MANGLE_H

#include <deque>
#include "namer.h"
#include "str.h"
#include "erlib.h"
#include "String.h"

class Mangle
{
    string _module, _name;
    int _noparams;

public:
    deque<Val> _parameters;
    Mangle();

    string mangle(string& module, string& name, int param);
    string mangle();
        // mangle name given we've demangled a name

    void demangle(string& name);
        // demangle a command line string x:y(a,b,c)

    void unmangle(string& name);
        // demangle a static function stmt funname/X

    string module();
    string name();
    int params();
};


#endif
