
/*
 *	Erlang Compiler with Monitoring Support
 *
 *	Geoff Wong (C) Copyright 1995/1996/1997.
 *	C/O RMIT University
 *	Swanston St. Melbourne 3000.
 *	Australia
 *
 *	email: geoff@cs.rmit.edu.au
 *
 *	This file is distributed under the terms of the 
 *	GNU Public License, details of which can be found
 *	in the file "Copying" which accompanies this code.
 */

/* 
 * A bundle of operators and basic nodes
 * Also includes all other nodes
 */

#ifndef _NODES_H
#define _NODES_H

#include "node.h"

#include "basic.h"
#include "expr.h"
#include "form.h"
#include "if.h"
#include "elist.h"
#include "pattern.h"
#include "receive.h"
#include "farity.h"
#include "function.h"

class Bracket : public Node
{
	Node * value;
public:
	Bracket(Node *);

	list<string> emit_code();
	string print();	
};

#endif

