
//
//    Erlang Compiler with Monitoring Support
//
//    Geoff Wong (C) Copyright 1996,1997,1998.
//    C/O RMIT University
//    Swanston St. Melbourne 3001.
//    Australia
//
//    email: geoff@serc.rmit.edu.au
//
//    This file is distributed under the terms of the 
//    GNU Public License, details of which can be found
//    in the file "Copying" which accompanies this code.
//

#ifndef _RECORD_H
#define _RECORD_H

#include "expr.h"
#include "program.h"

class Record : public Node
{
    Node * var;
    string     record;
    string     field;
    int     _index;

public:
    Record(Node * var, string r, string f);

    list<string> emit_code();
    string print();    
};

class NewRecord : public NodeList
{
    Program * program;

    string atom;

    string record;

public:

    NodeList * fields;

    NewRecord(string a, string r, NodeList * f);
        // take an existing atom, a record and setting exprs
        
    NewRecord(string r, NodeList * f);
        // create a new a record with  setting exprs

    string print();
    list<string> emit_code();
};

class Field : public Node
{
    string _field; 
    Node * _expr;

public:
    Field(const string &f, Node * e);

    list<string> emit_code();
    string print();

    string field() { return _field; };
    Node * expr() { return _expr; };
};

#endif
