//
// Socket object
// Basically a container for all the C stuff
//

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include <fcntl.h>
#include <strings.h>
#include <netinet/tcp.h>
#include "str.h"

class Socket 
{
	int     socket_no;
	long    int_address;
	int     string_address;
	int     port;
	int     family;
	int     socket_type;
	int 	protocol;

	char * 	hostname;
	char *  error;

public:
	Socket();
	Socket(int domain, int type, int prot);
		// create a socket of a certain name 
	Socket * Accept();
	int Bind(int port_number);
		// bind our socket to a name
	int Bind(const char * name);
	int Close();
	int Connect(const char * address);
	int Connect(const char * address, unsigned int port);
	int Connect(long addr, unsigned int port);
	int Fileno();
	char * Getpeername();
	char * Getsockopt(int level, int optname, int buflen);
	int Listen(int backlog);		
		// listen for a stream connection on our socket
	char * Recv(int bufsize);
	int Send(const char * what);
	int Sendto(const char * what, int flags, int address);
	int Setblocking(int flags);
		// set blocking/nonblock mode for the socket
	int Setsockopt(int level, int optname, char * value);
	int Shutdown(int how);
		// shut me down gracefully 
	void Set_error(const char * how);
	char * Query_error();
	char * Ip_number();
	char * Hostname();
};

const int MAX_BUFF =		2048;

