/*
** $Id: type_sup.h,v 1.1 1998/07/09 01:52:32 geoff Exp $
**
** $Source: /home/cvs/gerl/src/type_sup.h,v $
** $Revision: 1.1 $
** $Date: 1998/07/09 01:52:32 $
** $State: Exp $
**
** Copyright (C) Geoff Wong (1995, 1996, 1997, 1998)
** geoff@cs.rmit.edu.au
**
** This file is distributed under the terms of the
** GNU Public License, details of which can be found
** in the file "Copying" which accompanies this code.        
*/

#ifndef _TYPE_SUP_H
#define _TYPE_SUP_H

#include "erlib.h"

class Resolve
{
    EmitList param;

    EmitList utype;

    Resolve * next;

public:
    Resolve();

    Rlist add_resolve_list(Rlist a, Rlist b);

    void clean_up_resolve(Compile_type t1);

    Rlist make_resolve_list(EmitList param, EmitList utype);

    void resolve(Compile_type t1);

    int resolve_types(Compile_type t1, Compile_type t2, 
                        int restrict, char * where);
};

class CompileType
{
    CT_types flag;
    Utype type;
    unsigned int unknown;
    unsigned int misc;
    char constant;
    unsigned char depth;
    void * resolve;

public:

    CompileType();
        // Create a new unknown compile type

    CompileType(int type, int depth, int constant);
        // Generate a new (known) compile type

    CompileType operator=(CompileType &);

    bool basic_type(Etype x);
    string make_ctype_name();
    string make_itype_name(Etype t);
    string make_type_name(Etype t);
    string make_typesig();
    string type_to_str();
};


