#include "erlib.h"

#ifndef _TYPES
#define _TYPES


/*
 * Use bitflags for type checking
 */
typedef enum { T_invalid = 0, T_void = 1, T_number = 2, T_real = 4,
	T_string = 8, T_object = 16, T_mixed = 32, T_unknown = 64 }
	Types;
	
#define	T_NUM		8	/* left shift to get past basic types */
#define	T_NUM_VAL	17	/* highest legal type value + 1 */
#define T_MAX_DEPTH	8	/* maximum array depth */

/* we should check we don't max arrays > T_MAX_DEPTH - inline function? */
#define T_ANY		((1<<T_NUM)-1)
#define T_ARRAY(W,D)	(T_NUM_VAL*D+W)
#define ARRAY_TYPE(W)	(W%T_NUM_VAL)
#define ARRAY_DEPTH(W)  ((int)W/T_NUM_VAL)

/*
 * Internal Compiler Type representation
 */
typedef enum { CT_basic, CT_class, CT_unknown } CT_types;

typedef union {
	int basic;
	struct CLASS * iclass;
	int unknown;
} Utype;

typedef struct COMPILE_TYPE {
	CT_types flag;
	Utype type;
	unsigned int unknown;
	unsigned int misc;
	char constant;
	unsigned char depth;
	void * resolve;
} * Compile_type;

#endif
