
//
// $Id: unary.cc,v 1.2 2001/06/18 15:32:22 geoff Exp $
//
// $Source: /home/cvs/gerl/src/unary.cc,v $
// $Revision: 1.2 $
// $Date: 2001/06/18 15:32:22 $
// $State: Exp $
//
// Copyright (C) Geoff Wong (1996, 1997, 1998)
// geoff@cs.rmit.edu.au
//
// This file is distributed under the terms of the
// GNU Public License, details of which can be found
// in the file "Copying" which accompanies this code.        
//

#include "str.h"
#include "unary.h"

// Class Unary
Unary::Unary(const string& op, Node * l)
{
	LHS = l; 
	operate = op;
}

Unary::Unary(string * str, Node * l)
{
	LHS = l; 
	operate = *str;
}

list<string> Unary::emit_code()
{
    add_pre_code(LHS->pre_code());
	return string2list(operate + "(" + LHS->expr_code() + ")");
}

string Unary::print()
{
	return LHS->print() + operate;
}


UnaryMinus::UnaryMinus(Node * l) :
    Unary("Epreminus", l) 
{
}


list<string> UnaryMinus::emit_code()
{
    if (type() & LT_constant)
    {
        switch (type() & LT_single)
        {
            case LT_number:
               return string2list("EValint(-" + LHS->print() + ")");
            case LT_real:
               return string2list("EValreal(-" + LHS->print() + ")");
            default:
                return Unary::emit_code();
        }
    }
    return Unary::emit_code();
}

string UnaryMinus::print()
{
    return "-" + LHS->print();
}


UnaryPlus::UnaryPlus(Node * l):
    Unary("Epreplus", l) 
{
}

list<string> UnaryPlus::emit_code()
{
    add_pre_code(LHS->pre_code());
	return string2list("(" + LHS->expr_code() + ")");
}

string UnaryPlus::print()
{
    return LHS->print();
}

UnaryBnot::UnaryBnot(Node * l) :
    Unary("Ebnot", l) 
{
}

list<string> UnaryBnot::emit_code()
{
    return Unary::emit_code();
}

