

//
// $Id: unary.h,v 1.2 2001/06/18 15:32:22 geoff Exp $
//
// $Source: /home/cvs/gerl/src/unary.h,v $
// $Revision: 1.2 $
// $Date: 2001/06/18 15:32:22 $
// $State: Exp $
//
// Copyright (C) Geoff Wong (1996, 1997, 1998)
// geoff@cs.rmit.edu.au
//
// This file is distributed under the terms of the
// GNU Public License, details of which can be found
// in the file "Copying" which accompanies this code.        
//


#ifndef _UNARY_H
#define _UNARY_H

#include "node.h"

// Standard unary operates (with the same behaviour)
class Unary : public Node
{
protected:
	string operate;
	Node * LHS;
public:
	Unary(string *, Node *);

	Unary(const string& op, Node * l);
	list<string> emit_code();
	string print();
};

class UnaryMinus : public Unary
{
public:
    UnaryMinus(Node *);

    list<string> emit_code();
	string print();
};

class UnaryPlus : public Unary
{
public:
    UnaryPlus(Node *);

    list<string> emit_code();
	string print();
};

class UnaryBnot : public Unary
{
public:
    UnaryBnot(Node *);

    list<string> emit_code();
};


#endif
