
/*
	Abstract syntax tree support for my Erlang parser.

	Geoff Wong (C) Copyright 1995.
	C/O RMIT University
	Swanston St. Melbourne 3000.
	Australia

	email: geoff@cs.rmit.edu.au

	This file is distributed under the terms of the 
	GNU Public License, details of which can be found
	in the file "Copying" which accompanies this code.
*/

/*
	Erlang value stuff.

	- Types required for compile time and run time code.

*/

#ifndef _VALUES_H
#define _VALUES_H

typedef enum { 
		e_atom, 
		e_number,
		e_float,
		e_bool, 
		e_string, 
        e_token,
        e_pid,
        e_function,
        e_port,
		e_var,	
        e_tuple, 
		e_list
        } etypes;

struct list {
	int size;

};
typedef struct list * List;

#if 0
struct tuple {
	int size;

};
typedef struct tuple * Tuple;
#endif

typedef union {
	int number;
	char * atom;	
	char * string;
	char * var;
//	Tuple tuple;
	List list;
	int truth;
/*	Node node; */
} Many;

struct value {
	etypes type;
	Many v;
};

typedef struct value * Val;

#endif 
